GO.billing.BatchjobsGrid = function(config){
	
	if(!config)
	{
		config = {};
	}
	
	config.title = GO.billing.lang.batchjobs;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.store = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'batchjobs',
	    	book_id: 0
	    	
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','book_id','time','user_name','from_status_name','to_status_name','total'],
	    remoteSort: true
	});
	
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[
		{
			header: GO.billing.lang.time, 
			dataIndex: 'time'
		},		{
			header: GO.lang.strOwner, 
			dataIndex: 'user_name',
		  sortable: false
		},		{
			header: GO.billing.lang.fromStatusId, 
			dataIndex: 'from_status_name'
		},		{
			header: GO.billing.lang.toStatusId, 
			dataIndex: 'to_status_name'
		},{
			header: GO.billing.lang.totalOrders, 
			dataIndex: 'total'
		}
	]
	});
	
	config.cm=columnModel;
	
	
	config.tbar=[{
			iconCls: 'bs-send-email',
			text: GO.lang.strEmail,
			cls: 'x-btn-text-icon',
			scope: this,
			handler: function(){
				if(!GO.settings.modules.email)
				{
					Ext.Msg.alert(GO.lang['strError'], GO.billing.lang.noEmailModule);
				}else
				{
					var record=this.selModel.getSelected();						
					
					if(!record)
					{
						Ext.MessageBox.alert(GO.lang['strError'], GO.lang['noItemSelected']);
					}else
					{					
						GO.email.showComposer({
							loadUrl: GO.settings.modules.billing.url+'json.php',
							loadParams:{task:'sendmail_batchjob',batchjob_id: record.data.id},
							template_id: 0					
						});
					}
				}				
			}
		},{
			iconCls: 'btn-export',
			text: GO.lang.cmdExport,
			cls: 'x-btn-text-icon',
			scope: this,
			handler: function(){
				var record=this.selModel.getSelected();						
				
				if(!record)
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['noItemSelected']);
				}else
				{					
					document.location=GO.settings.modules.billing.url+'export.php?batchjob_id='+record.data.id;
				}							
			}
		}];
		
			
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	}),
	config.sm=new Ext.grid.RowSelectionModel({singleSelect: true});
	config.loadMask=true;		
	
	GO.billing.BatchjobsGrid.superclass.constructor.call(this, config);	
};

Ext.extend(GO.billing.BatchjobsGrid, GO.grid.GridPanel,{
	
});