/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @copyright Copyright Intermesh
 * @version $Id: 
 * @author Wilmar van Beusekom <wilmar@intermesh.nl>
 */

GO.billing.CostCodesGrid = function(config){
	
	config = config || {};

	config.title = GO.billing.lang.costCodes;
	//config.enableDragDrop=true;
	//config.ddGroup='bsItemsDD';
	
	//config.cls='bs-items-grid';
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.store = new GO.data.JsonStore({
			url : GO.settings.modules.billing.url + 'json.php',
			baseParams : {
				task : 'cost_codes',
				book_id:0
			},
			fields : ['id','code'],
			root : 'results',
			id : 'id',
			totalProperty : 'total'
		});
		
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[
		{
			header: GO.billing.lang.costCode,
			dataIndex: 'code',
			align:"left",
			//width:50,
			editor:this.codeField = new Ext.form.TextField({
				//width:80,
			  fieldLabel: GO.billing.lang.costCode,
			  name:'code'
			})
		}
	]
	});
	
	config.cm=columnModel;
	//config.autoExpandColumn='description';
	config.view=new Ext.grid.GridView({
		emptyText: GO.lang['strNoItems']
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;
	config.clicksToEdit=1;

	var Option = Ext.data.Record.create([
	// the "name" below matches the tag name to read, except "availDate"
	// which is mapped to the tag "availability"
	{
		name: 'id',
		type: 'int'
	},{
		name: 'book_id',
		type: 'int'
	},

	{
		name: 'code',
		type: 'string'
	}
	]);

	config.tbar=[{
		iconCls: 'btn-add',
		text: GO.lang['cmdAdd'],
		cls: 'x-btn-text-icon',
		handler: function(){
			var e = new Option({
				id: '0',
				book_id: this.store.baseParams.book_id,
				code:''
			});
			this.stopEditing();
			var rowIndex = this.store.getCount();
			this.store.insert(rowIndex, e);
			this.startEditing(rowIndex, 0);
		},
		scope: this
	},{
		iconCls: 'btn-delete',
		text: GO.lang['cmdDelete'],
		cls: 'x-btn-text-icon',
		handler: function(){
			this.deleteSelected();
		},
		scope: this
	}];

	GO.billing.CostCodesGrid.superclass.constructor.call(this, config);

	this.on('afteredit', function(e){
		Ext.Ajax.request({
			url : GO.settings.modules.billing.url + 'action.php',
			params : {
				task : 'save_cost_code',
				id : e.record.data.id,
				book_id:this.store.baseParams.book_id,
				code : e.record.data.code
			},
			scope : this,
			callback : function (options, success,response) {
				var responseParams = Ext.decode(response.responseText);
				if (!success) {
					Ext.Msg.alert(GO.lang['strError'], responseParams.feedback)
				}else
				{
					if(responseParams.cost_code_id){
						e.record.set('id', responseParams.cost_code_id);
					}
					
					e.record.commit();
				}
			}
		})
	}, this);
};

Ext.extend(GO.billing.CostCodesGrid, GO.grid.EditorGridPanel,{


	setBookId : function(book_id){
		if(this.store.baseParams.book_id!=book_id){
			this.store.baseParams.book_id=book_id;
			this.setDisabled(book_id==0);
			if(book_id>0){
				this.store.reload();
			}else
			{
				this.store.removeAll();
			}
		}
	}
	
	
});