GO.billing.ExpensePanel = function(config)
{
	Ext.apply(this, config);
	
	this.split=true;
	this.autoScroll=true;
	this.title=GO.billing.lang.expense;
	
		
	
	this.tbar = [
		this.editButton = new Ext.Button({
			iconCls: 'btn-edit', 
			text: GO.lang['cmdEdit'], 
			cls: 'x-btn-text-icon', 
			handler: function(){
				GO.billing.expenseDialog.show(this.data.id);
			}, 
			scope: this,
			disabled : true
		})
	];	
	
	
	GO.billing.ExpensePanel.superclass.constructor.call(this);		
}

Ext.extend(GO.billing.ExpensePanel, Ext.Panel,{
	
	initComponent : function(){
	
		var template = 
			'<div>'+
				'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
					'<tr>'+
						'<td colspan="2" class="display-panel-heading">'+GO.billing.lang.information+'</td>'+
					'</tr>'+
				
					'<tpl if="user_id.length">'+
						'<tr>'+
							'<td>'+GO.lang.strOwner+':</td><td>{user_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="expense_book_id.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.expenseBookId+':</td><td>{expense_book_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="category_id.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.categoryId+':</td><td>{category_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="company_id.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.companyId+':</td><td>{company_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="invoice_no.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.invoiceNo+':</td><td>{invoice_no}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="ctime.length">'+
						'<tr>'+
							'<td>'+GO.lang.strCtime+':</td><td>{ctime}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="mtime.length">'+
						'<tr>'+
							'<td>'+GO.lang.strMtime+':</td><td>{mtime}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="btime.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.btime+':</td><td>{btime}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="subtotal.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.subtotal+':</td><td>{subtotal}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="vat.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.vat+':</td><td>{vat}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="vat_percentage.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.vatPercentage+':</td><td>{vat_percentage}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="paid.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.paid+':</td><td>{paid}</td>'+
						'</tr>'+
					'</tpl>'+

									
				'</table>';																		
				
	    	
	  var config = {};
		
		
				
		template+='</div>';
		
		this.template = new Ext.XTemplate(template, config);
		
		GO.billing.ExpensePanel.superclass.initComponent.call(this);
	},
	
	loadExpense : function(expense_id)
	{
		this.body.mask(GO.lang.waitMsgLoad);
		Ext.Ajax.request({
			url: GO.settings.modules.billing.url+'json.php',
			params: {
				task: 'expense',
				expense_id: expense_id
			},
			callback: function(options, success, response)
			{
				this.body.unmask();
				if(!success)
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strRequestError']);
				}else
				{
					var responseParams = Ext.decode(response.responseText);
					this.setData(responseParams.data);
				}				
			},
			scope: this			
		});
		
	},
	
	setData : function(data)
	{
		this.data=data;
		this.editButton.setDisabled(!data.write_permission);
		
		
		
		this.template.overwrite(this.body, data);	
	}
	
});			