/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: ExportDialog.js 4569 2009-04-21 08:40:11Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
 
GO.billing.ExportDialog = Ext.extend(GO.ExportQueryDialog,{

	initComponent : function(){
		
		this.startField = new Ext.form.DateField({
		  name: 'start_date',
			anchor: '-20',
		  format: GO.settings.date_format,			  
		  fieldLabel: GO.billing.lang.startPeriod
		}),
		this.endField = new Ext.form.DateField({
		  name: 'end_date',
			anchor: '-20',
		  format: GO.settings.date_format,			  
		  fieldLabel: GO.billing.lang.endPeriod
		});
		
		this.formPanelItems.push(this.startField);
		this.formPanelItems.push(this.endField);
		
		GO.billing.ExportDialog.superclass.initComponent.call(this);
	},
	
	beforeRequest : function(){
		
		GO.billing.ExportDialog.superclass.beforeRequest.call(this);
		
		this.loadParams.text = '';
		var sd=this.startField.getValue();
		if(!GO.util.empty(sd))
		{
			this.loadParams.start_date=sd.format('U');	
			this.loadParams.text += this.startField.fieldLabel+': '+this.startField.getRawValue()+"\n";
		}else
		{
			delete this.loadParams.start_date;
		}
			
		var ed=this.endField.getValue();
		if(!GO.util.empty(ed))
		{
			this.loadParams.end_date=ed.format('U');
			this.loadParams.text += this.endField.fieldLabel+': '+this.endField.getRawValue()+"\n";
		}else
		{
			delete this.loadParams.end_date;
		}
		
		if(!GO.util.empty(this.searchQuery))
		{
			this.loadParams.subtitle=GO.lang.searchQuery+': '+this.searchQuery;
		}
		
		
	}
});
