GO.billing.MainPanel = function(config){
	
	if(!config)
	{
		config = GO.billing.LanguagesGrid;
	}
	this.booksPanel = new GO.billing.BooksGrid({
    region:'north',
    title:GO.billing.lang.books,
		autoScroll:true,				
		height:200,
		split:true
	});	
	
	var filterPanel = new GO.billing.OrdersFilterPanel({
		region:'center',
		title: GO.billing.lang.filter
	})
	
	filterPanel.on('change', function(filerGrid, orderStatuses, showScheduled){
		this.centerPanel.store.baseParams.order_statuses = Ext.encode(orderStatuses);
		this.centerPanel.store.baseParams.show_scheduled = showScheduled;		
		this.centerPanel.store.load();
		
		delete this.centerPanel.store.baseParams.order_statuses;
	}, this);

	GO.billing.orderStatusesStore.on('load', function(){
		this.displayPanel.reset();
	},this);
		
	var westPanel = new Ext.Panel({
		id:'bs-west-panel',
		region:'west',
		layout:'border',
		border: false,
		split:true,
		width:200,
		items:[this.booksPanel, filterPanel]
	});
	
	this.booksPanel.on('rowclick', function(grid, rowIndex)
	{
		var record = grid.getStore().getAt(rowIndex);	
		
		GO.billing.defaultVAT = record.data.default_vat;
		GO.billing.defaultCountry = record.data.country;
		this.setBookId(record.data.id);		
		
		this.centerPanel.setTitle(record.data.name);
	}, this);
	
	this.centerPanel = new GO.billing.OrdersGrid({
		id:'bs-orders-grid',
		region:'center',
		border:true,
		resizable:false
	});

	this.centerPanel.on('rowdblclick', function(grid, rowIndex){
		this.displayPanel.editHandler();
	}, this);
	
	this.centerPanel.store.on('load', function(){
		this.setWritePermission(this.centerPanel.store.reader.jsonData.write_permission);
	}, this);
	
	this.centerPanel.on("delayedrowselect",function(grid, rowIndex, r){
		if(this.eastPanel.isVisible())
			this.eastPanel.load(r.data.id);

		if(this.southPanel.isVisible())
			this.southPanel.load(r.data.id);
	}, this);

	var displayEast = Ext.state.Manager.get('bs-display-east');
	if(displayEast)
	{
		displayEast = Ext.decode(displayEast);
	}else
	{
		displayEast =screen.width>=1024;
	}

	var eastPanelConfig = {
		title: GO.billing.lang.order,
		border:true,
		region: 'east',
		width: 460,
		hidden: !displayEast,
		id:'bs-east-panel',
		collapseMode:'mini',
		collapsible:true,
		split:true
	};
	var southPanelConfig = {
		title: GO.billing.lang.order,
		border:true,
		region: 'south',
		height: 250,
		hidden: displayEast,
		id:'bs-south-panel',
		collapseMode:'mini',
		collapsible:true,
		split:true
	};

	
	this.displayPanel = this.eastPanel = new GO.billing.OrderPanel(eastPanelConfig);
	this.southPanel = new GO.billing.OrderPanel(southPanelConfig);

	var settingsMenu = [{
		iconCls: 'btn-settings',
		text: GO.lang.cmdSettings,
		cls: 'x-btn-text-icon',
		handler: function(){
			if(!this.settingsDialog)
			{
				this.settingsDialog = new GO.billing.SettingsDialog();
			}
			this.settingsDialog.show();
		},
		scope: this
	},{
		iconCls:'btn-toggle-window',
		text: GO.billing.lang.toggleInfoPanelPosition,
		cls: 'x-btn-text-icon',
		handler: function(){
			var id;

			if (this.eastPanel.isVisible()) {
				this.displayPanel = this.southPanel;
				this.eastPanel.hide();
				id= this.eastPanel.link_id;
			} else {
				this.displayPanel = this.eastPanel;
				this.southPanel.hide();
				id= this.southPanel.link_id;
			}
			
			this.displayPanel.show();
						
			this.displayPanel.ownerCt.doLayout();
			
			if(id){
				this.displayPanel.load(id);
			}

			this.displayPanel.show();
			//needed for chrome somehow
			this.displayPanel.getEl().applyStyles({'visibility':'visible'});
			this.displayPanel.expand();

			Ext.state.Manager.set('bs-display-east', Ext.encode(this.eastPanel.isVisible()));
		},
		scope: this
	}];
	
	config.tbar=new Ext.Toolbar({
			cls:'go-head-tb',
			items: [this.addButton = new Ext.Button({
			iconCls: 'btn-add',
			itemId:'add',
			text: GO.lang['cmdAdd'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.displayPanel.reset();
				GO.billing.showOrderDialog(0, {values : {book_id: this.centerPanel.store.baseParams.book_id}});				
			},
			scope: this
		}),this.deleteButton = new Ext.Button({
			iconCls: 'btn-delete',
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.centerPanel.deleteSelected({
					callback : this.displayPanel.gridDeleteCallback,
					scope: this.displayPanel
				});
			},
			scope: this
		}),this.settingsButton = new Ext.Button({
				iconCls: 'btn-settings',
				text: GO.lang.administration,
				cls: 'x-btn-text-icon',
				menu: settingsMenu,
				scope: this				
			}),this.catalogButton = new Ext.Button({
				iconCls: 'bs-btn-catalog',
				text: GO.billing.lang.catalog,
				cls: 'x-btn-text-icon',
				handler: function(){
					if(!this.catalogDialog)
					{
						this.catalogDialog = new GO.billing.CatalogDialog();
					}
					this.catalogDialog.show();
				},
				scope: this				
			}),this.expensesButton = new Ext.Button({
				itemId:'expenses',
				iconCls: 'bs-btn-expenses',
				text: GO.billing.lang.expenses,
				cls: 'x-btn-text-icon',
				handler: function(){
					if(!this.expensesWindow)
					{
						this.expensesWindow = new GO.billing.ExpensesWindow();
					}
					this.expensesWindow.show();
				},
				scope: this				
			}),this.batchjobButton = new Ext.Button({
				iconCls: 'bs-btn-batchjob',
				text: GO.billing.lang.batchjobs,
				cls: 'x-btn-text-icon',
				handler: function(){
					if(!this.batchjobDialog)
					{
						this.batchjobDialog = new GO.billing.BatchjobDialog();
					}
					this.batchjobDialog.show(this.centerPanel.store.baseParams.book_id);
					
				},
				scope: this
			}),this.exportButton = new Ext.Button({
				iconCls: 'btn-export',
				text: GO.billing.lang.cmdExport,
				cls: 'x-btn-text-icon',
				scope: this,
				handler: function(){
					if(!this.exportDialog)
					{
						this.exportDialog = new GO.billing.ExportDialog({
							query:'orders',
							title:GO.billing.lang.cmdExport
						});
					}			
					this.exportDialog.show({
						colModel:this.centerPanel.getColumnModel(),
						title:this.centerPanel.title,
						searchQuery: this.centerPanel.searchField.getValue()
					});
				}
			}),this.reportButton = new Ext.Button({
				iconCls: 'bs-btn-report',
				text: GO.billing.lang.report,
				cls: 'x-btn-text-icon',
				scope: this,
				handler: function(){
					if(!this.reportDialog)
					{
						this.reportDialog = new GO.billing.ReportDialog();
					}			
					this.reportDialog.show();
				}
			})]});
	
	config.items=[
	westPanel,
	this.largePanel = new Ext.Panel({
		border:false,
		region:'center',
		titlebar: false,
		layout:'border',
		items: [this.centerPanel,this.eastPanel,this.southPanel]
	})
	];	

	config.layout='border';
	GO.billing.MainPanel.superclass.constructor.call(this, config);
};

Ext.extend(GO.billing.MainPanel, Ext.Panel, {

	init : function(){
		this.getEl().mask(GO.lang.waitMsgLoad);
		Ext.Ajax.request({
			url: GO.settings.modules.billing.url+'json.php',
			params:{
				task:'init'
			},
			callback: function(options, success, response)
			{

				if(!success)
				{
					alert( GO.lang['strRequestError']);
				}else
				{
					var jsonData = Ext.decode(response.responseText);

					GO.billing.languagesStore.loadData(jsonData.languages);

					if(GO.webshop)
						GO.billing.webshopsStore.loadData(jsonData.webshops);

					GO.billing.writableBooksStore.loadData(jsonData.writable_books);
					GO.billing.readableBooksStore.loadData(jsonData.readable_books);
					

					this.booksPanel.getSelectionModel().selectFirstRow();
					var record = this.booksPanel.selModel.getSelected();

					if(record)
					{
						GO.billing.orderStatusesStore.baseParams.book_id=record.data.id;
						GO.billing.orderStatusesStore.loadData(jsonData.statuses);

						GO.billing.costCodesStore.loadData(jsonData.cost_codes);
						GO.billing.costCodesStore.baseParams.book_id=record.data.id;

						GO.billing.defaultVAT = record.data.default_vat;
						GO.billing.defaultCountry = record.data.country;
						this.setBookId(record.data.id);
						this.centerPanel.setTitle(record.data.name);
					}

					this.getEl().unmask();
				}
			},
			scope:this
		});
	},
	afterRender : function(){
		GO.billing.MainPanel.superclass.afterRender.call(this);

		if(GO.billing.max_orders>0){
			Ext.MessageBox.alert(GO.billing.lang.demoMode, GO.billing.lang.demoText.replace('%max_orders%', GO.billing.max_orders));
		}
			
		GO.billing.duplicateDialog = new GO.billing.DuplicateDialog();
		GO.billing.duplicateDialog.on('save', function(dialog, new_order_id, new_book_id){
			this.setBookId(new_book_id);
			
			var record = this.booksPanel.store.getById(new_book_id);
			this.booksPanel.selModel.selectRecords([record]);
			
			GO.billing.showOrderDialog(new_order_id);
		}, this);	

		GO.dialogListeners.add('order',{
			scope:this,
			save:function(){
				this.centerPanel.store.reload();
			}
		});

		this.init();
	},
	
	setWritePermission : function(write_permission){
		this.deleteButton.setDisabled(!write_permission);
		this.addButton.setDisabled(!write_permission);
		this.batchjobButton.setDisabled(!write_permission);
	
	},
	setBookId : function(book_id)
	{
		if(GO.billing.orderStatusesStore.baseParams.book_id!=book_id){
			GO.billing.orderStatusesStore.baseParams.book_id=this.book_id=book_id;
			GO.billing.orderStatusesStore.load();
		}

		GO.billing.costCodesStore.setBookId(book_id);
		
		this.centerPanel.store.baseParams.book_id = book_id;
		this.centerPanel.store.load();		
	}
});

GO.billing.defaultVAT = 0;
	

/*
 * This will add the module to the main tabpanel filled with all the modules
 */

if(!GO.addressbook){
	alert('The billing module requires the addressbook. The billing module is disabled');
}else
{
	GO.billing.showOrderDialog = function(order_id, config){

		if(!GO.billing.orderDialog)
			GO.billing.orderDialog = new GO.billing.OrderDialog();

		
		GO.billing.orderDialog.show(order_id, config);
	}

	
	GO.moduleManager.addModule('billing', GO.billing.MainPanel, {
		title : GO.billing.lang.billing,
		iconCls : 'go-tab-icon-billing'
	});
}
/*
 * If your module has a linkable item, you should add a link handler like this. 
 * The index (no. 1 in this case) should be a unique identifier of your item.
 * See classes/base/links.class.inc for an overview.
 * 
 * Basically this function opens a project window when a user clicks on it from a 
 * panel with links. 
 */
GO.linkHandlers[7]=function(id){

	if(!GO.billing.linkWindow){
		var orderPanel = new GO.billing.OrderPanel();
		GO.billing.linkWindow = new GO.LinkViewWindow({
			title: GO.billing.lang.order,
			items: orderPanel,
			orderPanel: orderPanel,
			closeAction:"hide"
		});		
	}
	GO.billing.linkWindow.orderPanel.load(id);
	GO.billing.linkWindow.show();
	
}

GO.linkPreviewPanels[7]=function(config){
	config = config || {};
	return new GO.billing.OrderPanel(config);
}
/* {LINKHANDLERS} */

GO.newMenuItems.push({
	text: GO.billing.lang.order,
	iconCls: 'go-link-icon-7',
	handler:function(item, e){
		
		if(!GO.billing.orderDialog)
			GO.billing.orderDialog = new GO.billing.OrderDialog();
				
		GO.billing.showOrderDialog(0, {
			link_config: item.parentMenu.link_config,	
			values: {book_id: ""}
		});
	}
});
/* {NEWMENUITEMS} */

