GO.billing.OrderPanel = Ext.extend(GO.DisplayPanel,{
	
	link_type : 7,
	
	loadParams : {
		task: 'order_with_items'
	},
	
	idParam : 'order_id',
	
	loadUrl : GO.settings.modules.billing.url+'json.php',

	stateId : 'bs-order-panel',

	editGoDialogId : 'order',
	
	editHandler : function(){
		if(this.data.read_only != '1'){
			GO.billing.showOrderDialog(this.link_id);
		}
	},
	initComponent : function(){


		this.orderStatusesStore = new GO.data.JsonStore({
			url: GO.settings.modules.billing.url+ 'json.php',
			baseParams: {
				task: 'order_statuses',
				book_id: 0
			},
			root: 'results',
			id: 'id',
			totalProperty:'total',
			fields: ['id','name', 'status_with_count', 'checked'],
			remoteSort: true
		});
	
		this.template = 
			
		'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
		'<tr><td valign="top">'+

		'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
		/*'<tr>'+
		'<td colspan="2" class="display-panel-heading">'+		
		'<tpl if="!GO.util.empty(order_id)">'+
			GO.billing.lang.informationAbout+' {order_id}</td>'+
		'</tpl>'+
		'<tpl if="!!GO.util.empty(order_id)">'+
			GO.billing.lang.sceduledOrder+
		'</tpl>'+
		'</tr>'+*/
					
		'<tpl if="!GO.util.empty(reference)">'+
		'<tr>'+
		'<td>'+GO.billing.lang.reference+':</td><td>{reference}</td>'+
		'</tr>'+
		'</tpl>'+
					
		'<tpl if="!GO.util.empty(btime)">'+
		'<tr>'+
		'<td>'+GO.billing.lang.btime+':</td><td>{btime}</td>'+
		'</tr>'+
		'</tpl>'+
					
					
				
		'<tr>'+
		'<td>'+GO.billing.lang.statusId+':</td><td>{status_name}</td>'+
		'</tr>'+
					

		'<tpl if="!GO.util.empty(po_id)">'+
		'<tr>'+
		'<td>'+GO.billing.lang.poId+':</td><td>{po_id}</td>'+
		'</tr>'+
		'</tpl>'+
					
					
		'<tpl if="!GO.util.empty(recur_type)">'+
		'<tr>'+
		'<td>'+GO.billing.lang.recurType+':</td><td>{[this.showRecurrence(values)]}</td>'+
		'</tr>'+
		'</tpl>'+


		'<tpl if="!GO.util.empty(payment_method)">'+
		'<tr>'+
		'<td>'+GO.billing.lang.paymentMethod+':</td><td>{payment_method}</td>'+
		'</tr>'+
		'</tpl>'+
					
					


		'<tr><td colspan="2">&nbsp;</td></tr>'+
		'<tr>'+
		'<td>'+GO.lang.strOwner+':</td><td>{user_name}</td>'+
		'</tr>'+
		'<tr>'+
		'<td>'+GO.lang.strCtime+':</td><td>{ctime}</td>'+
		'</tr>'+
		'<tr>'+
		'<td>'+GO.lang.strMtime+':</td><td>{mtime}</td>'+
		'</tr>'+
		'</table>'+

		'</td><td valign="top">'+

		'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
		'<tr>'+
		'<td colspan="2">{customer_name}<br />'+
		'<tpl if="!GO.util.empty(customer_contact_name)">'+
		'{customer_contact_name}<br />'+
		'</tpl>'+
		'<tpl if="!GO.util.empty(google_maps_link)">'+
		'<a href="{google_maps_link}" target="_blank">'+
		'</tpl>'+
		'{formatted_address}'+
		'<tpl if="!GO.util.empty(google_maps_link)">'+
		'</a>'+
		'</tpl>'+
		'<tpl if="!GO.util.empty(customer_email)">'+
		'<br /><br />{[GO.mailTo(values.customer_email)]}'+
		'</tpl>'+
		'</td>'+
		'</tr>'+
		'<tpl if="!GO.util.empty(customer_vat_no)">'+
		'<tr>'+
		'<td>'+GO.billing.lang.customerVatNo+':</td><td>{customer_vat_no}</td>'+
		'</tr>'+
		'</tpl>'+
		'</table>'+

		'</td></tr>'+
		'</table>'+


		'<tpl if="status_history.length">'+

		'<table class="display-panel bs-display-items" cellpadding="0" cellspacing="0" border="0">'+
		//LINK DETAILS
		'<tr>'+
		'<td colspan="4" class="display-panel-heading">'+GO.billing.lang.orderStatusHistory+'</td>'+
		'</tr>'+

		'<tr>'+
		'<td class="table_header_links">'+GO.billing.lang.statusId+'</td>'+
		'<td class="table_header_links">' + GO.lang.strOwner + '</td>'+
		'<td class="table_header_links" style="width:100px">'+GO.lang.strCtime+'</td>'+
		'<td class="table_header_links" style="width:50px">'+GO.billing.lang.notified+'</td>'+
		'</tr>'+

		'<tpl for="status_history">'+
		'<tr id="pm-status-history-{id}">'+
		'<td>{status_name}</td>'+
		'<td>{user_name}</div></td>'+
		'<td>{ctime}</td>'+
		'<td><tpl if="notified&gt;0"><div class="go-grid-icon btn-ok"><a href="#" onclick="GO.linkHandlers[9].call(this, 0, {path: \'{[Ext.util.Format.htmlEncode(values.notification_email)]}\'});">'+GO.lang.strView+'</a></div></tpl></td>'+
		'</tr>'+

		'</tpl>'+
		'</table>'+

		'</tpl>'+


					
		'<tpl if="items.length">'+

		'<table class="display-panel bs-display-items" cellpadding="0" cellspacing="0" border="0">'+
		//LINK DETAILS
		'<tr>'+
		'<td colspan="6" class="display-panel-heading">'+GO.billing.lang.items+'</td>'+
		'</tr>'+
						
		'<tr>'+
		'<td class="table_header_links" style="width:16px">'+GO.billing.lang.amount+'</td>'+
		'<td class="table_header_links">' + GO.lang['strDescription'] + '</td>'+
		'<td class="table_header_links">'+GO.billing.lang.unitPrice+'</td>'+
		'<td class="table_header_links">'+GO.billing.lang.subtotal+'</td>'+
		'<td class="table_header_links">'+GO.billing.lang.total+'</td>'+
		'<td class="table_header_links">'+GO.billing.lang.costCode+'</td>'+
		'</tr>'+
											
		'<tpl for="items">'+
		'<tr id="pm-item-row-{id}">'+
		'<td style="width:16px">{amount}</td>'+
		'<td>{description}</div></td>'+
		'<td style="white-space:nowrap">{unit_price}</td>'+
		'<td style="white-space:nowrap">{subtotal}</td>'+
		'<td style="white-space:nowrap">{total}</td>'+
		'<td style="white-space:nowrap">{cost_code}</td>'+
		'</tr>'+
													
		'</tpl>'+
		'</table>'+
					
		'</tpl>'+
					
					

		'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
		'<tr>'+
		'<td colspan="2" class="display-panel-heading">Totals</td>'+
		'</tr>'+
		'<tr>'+
		'<td>'+GO.billing.lang.costs+':</td><td>{costs}</td>'+
		'</tr>'+
		'<tr>'+
		'<td>'+GO.billing.lang.subtotal+':</td><td>{subtotal}</td>'+
		'</tr>'+
		'<tr>'+
		'<td>'+GO.billing.lang.vat+':</td><td>{vat}</td>'+
		'</tr>'+

		'<tr>'+
		'<td>'+GO.billing.lang.total+':</td><td>{total}</td>'+
		'</tr>'+

		'<tpl if="frontpage_text.length && frontpage_text!=\'&lt;br&gt;\' && frontpage_text!=\'&lt;br /&gt;\'">'+
		'<tr>'+
		'<td colspan="2" class="display-panel-heading">'+GO.billing.lang.frontpage+'</td>'+
		'</tr>'+
		'<tr>'+
		'<td colspan="2">{frontpage_text}</td>'+
		'</tr>'+
		'</tpl>'+

		'</table>';
												
		if(GO.customfields)
		{
			this.template +=GO.customfields.displayPanelTemplate;
		}

		if(GO.tasks)
			this.template +=GO.tasks.TaskTemplate;

		if(GO.calendar)
			this.template += GO.calendar.EventTemplate;

		this.template +=GO.linksTemplate;		
				
	    	
		Ext.apply(this.templateConfig,{
	  	
			showRecurrence : function(values)
			{
				var order_id = values.recurred_order_id;
				var d = values.recur_number+' ';
				switch(values.recur_type){
					case 'W':
						d+=GO.lang.strWeeks;
						break;
					case 'M':
						d+=GO.lang.strMonths;
						break;
					case 'Y':
						d+=GO.lang.strYears;
						break;
				}
	  		
				return '<a href="#" onclick="GO.linkHandlers[\'7\'].call(this, '+order_id+');">'+d+'</a>';
			}
		});
		
				
		if(GO.files)
		{
			Ext.apply(this.templateConfig, GO.files.filesTemplateConfig);
			this.template += GO.files.filesTemplate;
		}
		Ext.apply(this.templateConfig, GO.linksTemplateConfig);
		
		if(GO.comments)
		{
			this.template += GO.comments.displayPanelTemplate;
		}				
		
		GO.billing.OrderPanel.superclass.initComponent.call(this);
		
		if(GO.tasks)
		{
			this.scheduleCallItem = new GO.tasks.ScheduleCallMenuItem();
			this.newMenuButton.menu.add(this.scheduleCallItem);
		}		
	},
	
	reset : function(){
		
		this.getTopToolbar().setDisabled(true);
		GO.billing.OrderPanel.superclass.reset.call(this);
	},
	
	createTopToolbar : function(){
		
		var tbar = GO.billing.OrderPanel.superclass.createTopToolbar.call(this);

		tbar.splice(tbar.length-2,0 , this.actionsButton = new Ext.Button({
			iconCls: 'btn-actions', 
			cls: 'x-btn-text-icon', 
			text: GO.lang.cmdActions,		
			menu: new Ext.menu.Menu({
				items:[{
					iconCls: 'filetype-pdf',
					text: 'PDF',
					handler: function(){
						if(this.data.status_id>0)
						{
							document.location=GO.settings.modules.billing.url+'pdf.php?order_id='+this.data.id;
						}else
						{
							if(!GO.billing.orderStatusWindow)
							{
								GO.billing.orderStatusWindow = new GO.billing.OrderStatusWindow();
							}
							GO.billing.orderStatusWindow.show(this.data.id);
						}
					},
					scope: this
				},{
					iconCls: 'bs-send-email',
					text: GO.lang.strEmail,
					cls: 'x-btn-text-icon',
					handler: function(){
						if(!GO.settings.modules.email)
						{
							Ext.Msg.alert(GO.lang['strError'], GO.billing.lang.noEmailModule);
						}else
						{
							GO.email.showComposer({
								link_config:this.newMenuButton.menu.link_config,
								loadUrl: GO.settings.modules.billing.url+'json.php',
								loadParams:{
									task:'sendmail',
									order_id: this.data.id
								},
								template_id: 0					
							});
						}
						
					},
					scope:this						
				},{
					iconCls: 'bs-duplicate',
					text: GO.billing.lang.duplicate,
					cls: 'x-btn-text-icon',
					handler: function(){
						
						GO.mainLayout.tabPanel.setActiveTab('go-module-panel-billing');
						
						GO.billing.duplicateDialog.show(this.data.id, this.data.book_id);
					},
					scope:this						
				},{
					iconCls: 'bs-duplicate',
					text: GO.billing.lang.changeStatus,
					cls: 'x-btn-text-icon',
					menu: this.statusMenu = new Ext.menu.Menu({
						/*items: [
							{
								text: 'Aero Glass',
								checked: true,
								group: 'theme',
								checkHandler: onItemCheck
							}, {
								text: 'Vista Black',
								checked: false,
								group: 'theme',
								checkHandler: onItemCheck
							}, {
								text: 'Gray Theme',
								checked: false,
								group: 'theme',
								checkHandler: onItemCheck
							}, {
								text: 'Default Theme',
								checked: false,
								group: 'theme',
								checkHandler: onItemCheck
							}
						]*/
						})
				}]
			})			
		}));

		return tbar;
	},
	
	
	
	getLinkName : function(){
		return this.data.order_id;
	},

	setStatusMenu : function(){

		if(this.orderStatusesStore.baseParams.book_id!=this.data.book_id){
			this.orderStatusesStore.baseParams.book_id=this.data.book_id;
			this.orderStatusesStore.load({
				callback:function(){
					this.statusMenu.removeAll();
					this.suppressCheck=true;
					this.orderStatusesStore.each(function(r)
					{
						this.statusMenu.add({
							text:r.data.name,
							status_id:r.data.id,
							group:'status-'+this.getId(),
							checked:this.data.status_id==r.data.id,
							checkHandler:function(i){
								if(!this.suppressCheck){
									Ext.Msg.show({
										modal:false,
										title:GO.billing.lang.notifyCustomer,
										msg: GO.billing.lang.notifyCustomerText,
										buttons: Ext.Msg.YESNOCANCEL,
										fn: function(btn){
											if(btn=='cancel'){

												//reset the checked item
												this.suppressCheck=true;
												this.statusMenu.items.each(function(i){
													i.setChecked(i.status_id==this.data.status_id, true);
												}, this);
												this.suppressCheck=false;

												return false;
											}
											Ext.Ajax.request({
												url:GO.settings.modules.billing.url+'action.php',
												params:{
													task:'change_status',
													order_id: this.data.id,
													status_id:i.status_id,
													notify_customer: btn=='yes' ? 1 : 0
												},
												callback:function(options, success, response){

													var data = Ext.decode(response.responseText);

													if(!data.success)
													{
														Ext.Msg.alert(GO.lang['strError'], data.feedback);
													}else
													{
														this.reload();
														//check if it's not a popup

														var billing = GO.mainLayout.getModulePanel('billing');

														if(billing.centerPanel.store.baseParams.book_id==this.data.book_id){
															billing.centerPanel.store.reload();
														}
													}
												},
												scope:this
											});
										},
										scope:this,
										icon: Ext.MessageBox.QUESTION
									});
								}
							},
							scope:this
						});
					}, this);
					this.suppressCheck=false;
				},
				scope:this
			});
			
		}else
		{
			this.suppressCheck=true;
			this.statusMenu.items.each(function(i){
				i.setChecked(i.status_id==this.data.status_id, true);
			}, this);
			this.suppressCheck=false;
		}
	},
	
	setData : function(data)
	{
		GO.billing.OrderPanel.superclass.setData.call(this, data);

		var title = !GO.util.empty(data.order_id) ? GO.billing.lang.informationAbout+' '+data.order_id : GO.billing.lang.sceduledOrder;
		this.setTitle(title);
		
		this.setStatusMenu();
		
		this.getTopToolbar().setDisabled(!data.write_permission);
		if(this.data.read_only == '1')
			this.editButton.disable();
		
		if(data.write_permission)
		{
			if(this.scheduleCallItem)
			{	
				var name = this.data.customer_name;
				
				if(this.data.order_id!='0')
				{
					name += ' ('+this.data.order_id+')';
				}
				
				this.scheduleCallItem.setLinkConfig({
					name: name,
					links:[{
						link_id: this.data.id,
						link_type:7
					}, {
						link_id: this.data.contact_id,
						link_type:2
					}, {
						link_id: this.data.company_id,
						link_type:3
					}],
					callback:this.reload,
					scope: this
				});
			}
		}
	}	
});			
