GO.billing.OrderStatusesGrid = function(config){
	
	if(!config)
	{
		config = {};
	}
	
	config.title = GO.billing.lang.orderStatuses;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.store = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'order_statuses',
	    	for_settings: true,
	    	book_id: 0	    	
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['color','id','name','max_age','payment_required','remove_from_stock'],
	    remoteSort: true
	});
	
	config.paging=false;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[
	  {
			header: GO.lang.strName, 
			dataIndex: 'name',
			renderer: function(value,meta,record) {
				return '<div style="background-color: #'+record.data.color+';border: 1px solid #666;width:9px;height:9px;margin-right:4px;float:left;"></div>'+value;
			}
		},	{
			header: GO.billing.lang.paymentRequired, 
			dataIndex: 'payment_required',
			renderer: this.boolRender
		},		{
			header: GO.billing.lang.removeFromStock, 
			dataIndex: 'remove_from_stock',
			renderer: this.boolRender
		}
	]
	});
	
	config.cm=columnModel;
	
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	}),
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;
	
	
	this.orderStatusDialog = new GO.billing.OrderStatusDialog();
	    			    		
		this.orderStatusDialog.on('save', function(){   
			this.store.reload();	    			    			
		}, this);
	
	
	config.tbar=[{
			iconCls: 'btn-add',							
			text: GO.lang['cmdAdd'],
			cls: 'x-btn-text-icon',
			handler: function(){
				
	    	this.orderStatusDialog.show();
	    	this.orderStatusDialog.formPanel.baseParams.book_id=this.store.baseParams.book_id;
	    	
	    	
	    	
			},
			scope: this
		},{
			iconCls: 'btn-delete',
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.deleteSelected();
			},
			scope: this
		}];
		
	config.disabled=true;	
	
	GO.billing.OrderStatusesGrid.superclass.constructor.call(this, config);
	
	this.on('rowdblclick', function(grid, rowIndex){
		var record = grid.getStore().getAt(rowIndex);	
		
		this.orderStatusDialog.show(record.data.id);
		
		}, this);
	
};

Ext.extend(GO.billing.OrderStatusesGrid, GO.grid.GridPanel,{
	setBookId : function(book_id){
		this.setDisabled(book_id==0);
		this.store.baseParams.book_id=book_id;
		this.store.loaded=false;
	},
	boolRender : function(value)
	{
		if(value=="1")
		{
			return GO.lang.cmdYes;
		}else
		{
			return GO.lang.cmdNo;
		}
	},
	onShow : function(){
		if(!this.store.loaded)
		{
			this.store.load();
		}
		
		GO.billing.OrderStatusesGrid.superclass.onShow.call(this);
	}
});