GO.billing.OrdersFilterPanel = function(config)
{
	if(!config)
	{
		config = {};
	}
	
	var checkColumn = new GO.grid.CheckColumn({
		header: '&nbsp;',
		dataIndex: 'checked',
		width: 30
	});
	
	config.layout='fit';
	
	Ext.apply(config, {
		cls:'go-grid3-hide-headers',
		autoScroll:true,
		disableSelection:true,
		border:false,
		loadMask:true,
		store: GO.billing.orderStatusesStore,		
		columns: [
				checkColumn,
				{
					header: GO.lang.strName, 
					dataIndex: 'status_with_count',
					id:'name'
				}				
			],
		//sm: new Ext.grid.RowSelectionModel({singleSelect:singleSelect}),
		plugins: [checkColumn],
		autoExpandColumn:'name'
	});
	
	
	
	var applyButton = new Ext.Button({
		text:GO.lang.cmdApply,
		handler:function(){
			
			var orderStatuses = [];
			
			for (var i = 0; i < GO.billing.orderStatusesStore.data.items.length;  i++)
			{
				var checked = GO.billing.orderStatusesStore.data.items[i].get('checked');
				if(checked=="1")
				{
					orderStatuses.push(GO.billing.orderStatusesStore.data.items[i].get('id'));	
				}				
			}
			
			this.fireEvent('change', this, orderStatuses, this.showScheduledField.getValue());
			
			GO.billing.orderStatusesStore.commitChanges();			
		},
		scope: this
	});
	
	config.tbar=[this.showScheduledField = new Ext.form.Checkbox({
				boxLabel: GO.billing.lang.showScheduledOrders,
				labelSeparator: '',
				name: 'show_Scheduled',		
				allowBlank: true,
				ctCls:'bs-scheduled-cb'
			})];
	config.buttons=[applyButton];
	
	/*config.items=[
	this.statusFilterGrid,
	new Ext.Panel({
		border:false,
		cls:'go-form-panel',waitMsgTarget:true,
		items:[	
			new GO.form.HtmlComponent({html: '<br />'}),
			this.showScheduledField = new Ext.form.Checkbox({
				boxLabel: GO.billing.lang.showScheduledOrders,
				labelSeparator: '',
				name: 'show_Scheduled',		
				allowBlank: true
			}),
			new GO.form.HtmlComponent({html: '<br />'}), 
			applyButton
			]
	})];*/
	
	GO.billing.OrdersFilterPanel.superclass.constructor.call(this, config);
	
	this.addEvents({change : true});
}

Ext.extend(GO.billing.OrdersFilterPanel, GO.grid.GridPanel);