GO.billing.OrdersGrid = function(config){
	
	if(!config)
	{
		config = {};
	}

	var fields ={
		fields : [
		'id',
		'late',
		'status_id',
		'status_name',
		'user_name',
		'order_id',
		'po_id',
		'ctime',
		'mtime',
		'btime',
		'ptime',
		'costs',
		'subtotal',
		'vat',
		'total',
		'customer_name',
		'customer_contact_name',
		'customer_address',
		'customer_address_no',
		'customer_zip',
		'customer_city',
		'customer_state',
		'customer_country',
		'customer_vat_no',
		'customer_email',
		'customer_extra',
		'recur_type',
		'payment_method',
		'recurred_order_id',
		'reference',
		'read_only',
		'color'],
		columns :[
		{
			header: GO.billing.lang.orderId,
			dataIndex: 'order_id',
			renderer: this.renderOrderId,
			width:110
		},		{
			header: GO.billing.lang.btime,
			dataIndex: 'btime',
			width:80
		},{
			header: GO.billing.lang.statusId,
			dataIndex: 'status_name',
			width:120,
			renderer: function(value,meta,record) {
				return '<div style="background-color: #'+record.data.color+';border: 1px solid #666;width:9px;height:9px;margin-right:4px;float:left;"></div>'+value;
			}
		},		{
			header: GO.billing.lang.pTime,
			dataIndex: 'ptime',
			hidden:true
		},		{
			header: GO.billing.lang.customer,
			dataIndex: 'customer_name',
			id:'customer'
		},{
			header: GO.billing.lang.paymentMethod,
			dataIndex: 'payment_method'
		},		{
			header: GO.billing.lang.reference,
			dataIndex: 'reference'
		},{
			header: GO.billing.lang.poId,
			dataIndex: 'po_id',
			hidden:true
		},			{
			header: GO.billing.lang.costs,
			dataIndex: 'costs',
			hidden:true,
			align: 'right'
		},		{
			header: GO.billing.lang.subtotal,
			dataIndex: 'subtotal',
			align: 'right'
		},		{
			header: GO.billing.lang.vat,
			dataIndex: 'vat',
			hidden:true,
			align: 'right'
		},{
			header: GO.billing.lang.total,
			dataIndex: 'total',
			align: 'right'
		},	{
			header: GO.lang.strMtime,
			dataIndex: 'mtime',
			hidden: true
		},		{
			header: GO.lang.strCtime,
			dataIndex: 'ctime',
			hidden:true
		},		{
			header: GO.billing.lang.customerContact,
			dataIndex: 'customer_contact_name',
			hidden:true
		}
		,		{
			header: GO.lang.strAddress,
			dataIndex: 'customer_address',
			hidden:true
		},		{
			header: GO.lang.strNo,
			dataIndex: 'customer_address_no',
			hidden:true
		},		{
			header: GO.lang.strZip,
			dataIndex: 'customer_zip',
			hidden:true
		},		{
			header: GO.lang.strCity,
			dataIndex: 'customer_city',
			hidden:true
		},		{
			header: GO.lang.strState,
			dataIndex: 'customer_state',
			hidden:true
		},		{
			header: GO.lang.strCountry,
			dataIndex: 'customer_country',
			hidden:true
		},		{
			header: GO.billing.lang.customerVatNo,
			dataIndex: 'customer_vat_no',
			hidden:true
		},		{
			header: GO.lang.strEmail,
			dataIndex: 'customer_email',
			hidden:true
		},		{
			header: GO.billing.lang.customerExtra,
			dataIndex: 'customer_extra',
			hidden:true
		}
		]
	};

	if(GO.customfields)
	{
		GO.customfields.addColumns(7, fields);
	}
	
	config.title = GO.billing.lang.orders;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.autoExpandColumn='customer';
	config.store = new GO.data.JsonStore({
		url: GO.settings.modules.billing.url+ 'json.php',
		baseParams: {
			task: 'orders',
			book_id: 0	    	
		},
		root: 'results',
		id: 'id',
		totalProperty:'total',
		fields: fields.fields,
		remoteSort: true
	});
	config.store.setDefaultSort('btime','DESC');
	
	this.searchField = new GO.form.SearchField({
		store: config.store,
		width:320
	});
	
	config['tbar']=[
	GO.lang['strSearch']+': ', ' ',this.searchField
	];
	
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:fields.columns
	});
	
	config.cm=columnModel;
	
	config.view=new Ext.grid.GridView({
		emptyText: GO.lang['strNoItems'],
		getRowClass: function(record, index){

			if(record.data.late || record.data.status_id==0)
			{
				return 'bs-late';
			}
		}
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	GO.billing.OrdersGrid.superclass.constructor.call(this, config);
	
};

Ext.extend(GO.billing.OrdersGrid, GO.grid.GridPanel,{
	
	renderOrderId : function(id,cell,record){
		
		if(id==0)
		{
			id=GO.billing.lang.sceduledOrder;
		}
		
		var cls = 'bs-order-id';
		if(record.data.recur_type!='')
			cls += ' bs-icon-recur';
			
		return '<div class="'+cls+'">'+id+'</div>';
	}
});