GO.billing.ProductPanel = function(config)
{
	Ext.apply(this, config);
	
	this.split=true;
	this.autoScroll=true;
	this.title=GO.billing.lang.product;
	
		
	
	this.tbar = [
		this.editButton = new Ext.Button({
			iconCls: 'btn-edit', 
			text: GO.lang['cmdEdit'], 
			cls: 'x-btn-text-icon', 
			handler: function(){
				GO.billing.productDialog.show(this.data.id);
			}, 
			scope: this,
			disabled : true
		})
	];	
	
	
	GO.billing.ProductPanel.superclass.constructor.call(this);		
}

Ext.extend(GO.billing.ProductPanel, Ext.Panel,{
	
	initComponent : function(){
	
		var template = 
			'<div>'+
				'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
					'<tr>'+
						'<td colspan="2" class="display-panel-heading">'+GO.billing.lang.information+'</td>'+
					'</tr>'+
				
					'<tpl if="sort_order.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.sortOrder+':</td><td>{sort_order}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="category_id.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.categoryId+':</td><td>{category_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="image.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.image+':</td><td>{image}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="cost_price.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.costPrice+':</td><td>{cost_price}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="list_price.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.listPrice+':</td><td>{list_price}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="vat.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.vat+':</td><td>{vat}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="total_price.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.totalPrice+':</td><td>{total_price}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="supplier_company_id.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.supplierCompanyId+':</td><td>{supplier_company_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="supplier_product_id.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.supplierProductId+':</td><td>{supplier_product_id}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="allow_bonus_points.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.allowBonusPoints+':</td><td>{allow_bonus_points}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="special.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.special+':</td><td>{special}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="special_list_price.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.specialListPrice+':</td><td>{special_list_price}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="special_total_price.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.specialTotalPrice+':</td><td>{special_total_price}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="charge_shipping_costs.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.chargeShippingCosts+':</td><td>{charge_shipping_costs}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="stock.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.stock+':</td><td>{stock}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="bonus_points.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.bonusPoints+':</td><td>{bonus_points}</td>'+
						'</tr>'+
					'</tpl>'+


					'<tpl if="required_products.length">'+
						'<tr>'+
							'<td>'+GO.billing.lang.requiredProducts+':</td><td>{required_products}</td>'+
						'</tr>'+
					'</tpl>'+

									
				'</table>';																		
				
	    	
	  var config = {};
		
		
				
		template+='</div>';
		
		this.template = new Ext.XTemplate(template, config);
		
		GO.billing.ProductPanel.superclass.initComponent.call(this);
	},
	
	loadProduct : function(product_id)
	{
		this.body.mask(GO.lang.waitMsgLoad);
		Ext.Ajax.request({
			url: GO.settings.modules.billing.url+'json.php',
			params: {
				task: 'product_with_items',
				product_id: product_id
			},
			callback: function(options, success, response)
			{
				this.body.unmask();
				if(!success)
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strRequestError']);
				}else
				{
					var responseParams = Ext.decode(response.responseText);
					this.setData(responseParams.data);
				}				
			},
			scope: this			
		});
		
	},
	
	setData : function(data)
	{
		this.data=data;
		this.editButton.setDisabled(!data.write_permission);
		
		
		
		this.template.overwrite(this.body, data);	
	}
	
});			