/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: SelectProductDialog.js 7619 2010-04-13 08:44:12Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
 
 
GO.billing.SelectProductDialog = function(config){
	
	
	if(!config)
	{
		config={};
	}
	
	this.categoriesTree = new GO.billing.CategoriesTree({
		region:'west',
		split:true,
		title:GO.billing.lang.categories,
		enableDD: true
		
	});
	
	this.categoriesTree.on('click', function(node)	{
		this.setCategory(node.id.substr(10));
	}, this);
	
	this.productsGrid = new GO.billing.ProductsGrid({
		region:'center',
		enableDragDrop:true,
		deleteConfig: {
				scope:this,
				success:function(){
				  var activeNode = this.categoriesTree.getNodeById('bs-folder-'+this.category_id);
				  if(activeNode)
				  {
				  	activeNode.reload();
				  }else
				  {
				  	this.categoriesTree.getRootNode().reload();
				  }
				}
			}
	});
	

	
	
	config.iconCls='bs-btn-catalog';
	config.layout='border';
	config.modal=false;
	config.resizable=true;
	config.maximizable=true;
	config.width=700;
	config.height=400;
	config.closeAction='hide';
	config.title= GO.billing.lang.productCatalog;					
	config.items=[this.categoriesTree, this.productsGrid];
	

	this.productsGrid.on("rowdblclick", this.rowDoulbleClicked, this);
	
	GO.billing.SelectProductDialog.superclass.constructor.call(this, config);
	
	this.addEvents({'productselect':true});
}

Ext.extend(GO.billing.SelectProductDialog, Ext.Window,{
	
	afterRender : function(){
		
		GO.billing.CatalogPanel.superclass.afterRender.call(this);		
		this.setCategory(0);
	},
	rowDoulbleClicked : function(grid, rowClicked, e) {
			
		var selectionModel = grid.getSelectionModel();
		var record = selectionModel.getSelected();
		
		var type = record.data.id.substr(0,1);
		var id = record.data.id.substr(2);
		
		if(type=='f')
		{
			this.setCategory(id);			
		}else	
		{
			this.fireEvent('productselect', record);
			this.hide();
		}
	},
	
	setCategory : function(category_id)
	{
		var activeNode = this.categoriesTree.getNodeById('bs-folder-'+category_id);
		if(activeNode)
		{
			activeNode.expand();			
		}		
		this.category_id=category_id;
		this.productsGrid.store.baseParams["category_id"]=category_id;
		this.productsGrid.store.load();
	}
});

