
GO.billing.costCodesStore = new GO.data.JsonStore({
	url : GO.settings.modules.billing.url + 'json.php',
	baseParams : {
		task : 'cost_codes',
		book_id:0
	},
	fields : ['id','code'],
	root : 'results',
	id : 'id',
	totalProperty : 'total',
	setBookId : function(book_id){
		if(this.baseParams.book_id!=book_id){
			this.baseParams.book_id=book_id;
			this.reload();
		}
	}
});



GO.billing.orderStatusesStore =  new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'order_statuses',
	    	book_id: 0	    	
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','name', 'status_with_count', 'checked'],
	    remoteSort: true
	});

GO.billing.languagesStore = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'languages'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','language','name'],
	    remoteSort: true
	});
	
GO.billing.expenseCategoriesStore = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'expense_categories',
	    	expense_book_id: 0	    	
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','expense_book_id','name'],
	    remoteSort: true
		});
		
GO.billing.readableBooksStore =  new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'books',
	    	auth_type: 'read'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','name', 'default_vat','country'],
	    remoteSort: true
	});
	
GO.billing.writableBooksStore =new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'books',
	    	auth_type: 'write'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','name', 'user_name', 'report_checked','country'],
	    remoteSort: true
	});

GO.billing.writableBooksStore.on('load', function(){
			GO.billing.writableBooksStore.on('load', function(){
				GO.billing.readableBooksStore.load();
			}, this);
		}, this, {single:true});

	
	
	
GO.billing.writableExpenseBooksStore = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'expense_books',
	    	auth_type: 'write'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','user_name','name','currency','vat', 'report_checked'],
	    remoteSort: true
	});
GO.billing.writableExpenseBooksStore.on('load', function(){
		GO.billing.readableExpenseBooksStore.load();
	}, this);
	
GO.billing.readableExpenseBooksStore = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'expense_books',
	    	auth_type: 'read'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','user_name','acl_id','name','currency','vat'],
	    remoteSort: true
	});
	
if(GO.webshop)
{
	GO.billing.webshopsStore = new GO.data.JsonStore({
	    url: GO.settings.modules.billing.url+ 'json.php',
	    baseParams: {
	    	task: 'webshops'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: ['id','name'],
	    remoteSort: true
	}); 
}