
-- Tabelstructuur voor tabel `bs_batchjobs`
--

DROP TABLE IF EXISTS `bs_batchjobs`;
CREATE TABLE IF NOT EXISTS `bs_batchjobs` (
  `id` int(11) NOT NULL default '0',
  `book_id` int(11) NOT NULL default '0',
  `time` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `from_status_id` int(11) NOT NULL default '0',
  `to_status_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `book_id` (`book_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_batchjob_orders`
--

DROP TABLE IF EXISTS `bs_batchjob_orders`;
CREATE TABLE IF NOT EXISTS `bs_batchjob_orders` (
  `batchjob_id` int(11) NOT NULL default '0',
  `order_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`batchjob_id`,`order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_books`
--

DROP TABLE IF EXISTS `bs_books`;
CREATE TABLE IF NOT EXISTS `bs_books` (
  `id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `name` varchar(100) default NULL,
  `acl_id` int(11) NOT NULL default '0',
  `order_id_prefix` varchar(50) default NULL,
  `show_statuses` varchar(100) default NULL,
  `next_id` int(11) NOT NULL default '0',
  `default_vat` double NOT NULL default '0',
  `currency` varchar(10) default NULL,
  `order_csv_template` text,
  `item_csv_template` text,
  `country` char(2) NOT NULL,
  `bcc` varchar(100) default NULL,
  `call_after_days` tinyint(4) NOT NULL,
  `sender_email` varchar(100) DEFAULT NULL,
  `sender_name` varchar(100) DEFAULT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_category_languages`
--

DROP TABLE IF EXISTS `bs_category_languages`;
CREATE TABLE IF NOT EXISTS `bs_category_languages` (
  `language_id` int(11) NOT NULL default '0',
  `category_id` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  PRIMARY KEY  (`language_id`,`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_expenses`
--

DROP TABLE IF EXISTS `bs_expenses`;
CREATE TABLE IF NOT EXISTS `bs_expenses` (
  `id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `expense_book_id` int(11) NOT NULL default '0',
  `category_id` int(11) NOT NULL default '0',
  `supplier` varchar(100) default NULL,
  `invoice_no` varchar(50) default NULL,
  `ctime` int(11) NOT NULL default '0',
  `mtime` int(11) NOT NULL default '0',
  `btime` int(11) default '0',
  `ptime` int(11) default NULL,
  `subtotal` double NOT NULL default '0',
  `vat` double NOT NULL default '0',
  `invoice_id` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `book_id` (`expense_book_id`,`category_id`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_expense_books`
--

DROP TABLE IF EXISTS `bs_expense_books`;
CREATE TABLE IF NOT EXISTS `bs_expense_books` (
  `id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `acl_id` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  `currency` varchar(10) default NULL,
  `vat` double NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_expense_categories`
--

DROP TABLE IF EXISTS `bs_expense_categories`;
CREATE TABLE IF NOT EXISTS `bs_expense_categories` (
  `id` int(11) NOT NULL default '0',
  `expense_book_id` int(11) NOT NULL default '0',
  `name` varchar(100) default NULL,
  PRIMARY KEY  (`id`),
  KEY `book_id` (`expense_book_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_items`
--

DROP TABLE IF EXISTS `bs_items`;
CREATE TABLE IF NOT EXISTS `bs_items` (
  `id` int(11) NOT NULL default '0',
  `order_id` int(11) NOT NULL default '0',
  `product_id` int(11) NOT NULL default '0',
  `description` text,
  `unit_cost` double NOT NULL default '0',
  `unit_price` double NOT NULL default '0',
  `unit_list` double NOT NULL default '0',
  `unit_total` double NOT NULL default '0',
  `amount` double NOT NULL default '0',
  `vat` double NOT NULL default '0',
  `discount` double NOT NULL default '0',
  `sort_order` int(11) NOT NULL default '0',
	`cost_code` varchar(50) default NULL,
  `markup` double NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `order_id` (`order_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_languages`
--

DROP TABLE IF EXISTS `bs_languages`;
CREATE TABLE IF NOT EXISTS `bs_languages` (
  `id` int(11) NOT NULL default '0',
  `language` varchar(10) default NULL,
  `name` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_numbers`
--

DROP TABLE IF EXISTS `bs_numbers`;
CREATE TABLE IF NOT EXISTS `bs_numbers` (
  `book_id` int(11) NOT NULL default '0',
  `type` tinyint(4) NOT NULL default '0',
  `next_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`book_id`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_orders`
--

DROP TABLE IF EXISTS `bs_orders`;
CREATE TABLE IF NOT EXISTS `bs_orders` (
  `id` int(11) NOT NULL default '0',
  `status_id` int(11) NOT NULL default '0',
  `book_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `order_id` varchar(20) NOT NULL,
  `po_id` varchar(50) NOT NULL,
  `company_id` int(11) NOT NULL default '0',
  `contact_id` int(11) NOT NULL default '0',
  `ctime` int(11) NOT NULL default '0',
  `mtime` int(11) NOT NULL default '0',
  `btime` int(11) NOT NULL default '0',
  `ptime` int(11) NOT NULL,
  `costs` double NOT NULL default '0',
  `subtotal` double NOT NULL default '0',
  `vat` double NOT NULL default '0',
  `total` double NOT NULL default '0',
  `authcode` varchar(50) default NULL,
  `frontpage_text` text NOT NULL,
  `customer_name` varchar(50) default NULL,
  `customer_to` VARCHAR( 255 ) NOT NULL,
  `customer_salutation` varchar(100) default NULL,
  `customer_contact_name` varchar(50) default NULL,
  `customer_address` varchar(50) default NULL,
  `customer_address_no` varchar(50) default NULL,
  `customer_zip` varchar(20) default NULL,
  `customer_city` varchar(50) default NULL,
  `customer_state` varchar(50) default NULL,
  `customer_country` char(2) NOT NULL,
  `customer_vat_no` varchar(50) default NULL,
  `customer_email` varchar(100) default NULL,
  `customer_extra` varchar(255) NOT NULL,
  `webshop_id` int(11) NOT NULL default '0',
  `recur_type` varchar(10) NOT NULL,
  `payment_method` varchar(50) NOT NULL,
  `recurred_order_id` int(11) NOT NULL default '0',
  `reference` varchar(100) NOT NULL,
  `order_bonus_points` int(11) default NULL,
  `pagebreak` enum('0','1') NOT NULL,
  `files_folder_id` int(11) NOT NULL,
	`cost_code` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `company_id` (`company_id`),
  KEY `book_id` (`book_id`),
  KEY `status_id` (`status_id`),
  KEY `recurred_order_id` (`recurred_order_id`)

) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_order_statuses`
--

DROP TABLE IF EXISTS `bs_order_statuses`;
CREATE TABLE IF NOT EXISTS `bs_order_statuses` (
  `id` int(11) NOT NULL default '0',
  `book_id` int(11) NOT NULL default '0',
  `max_age` int(11) NOT NULL default '0',
  `payment_required` enum('0','1') NOT NULL default '0',
  `remove_from_stock` enum('0','1') NOT NULL,
  `read_only` enum('0','1') NOT NULL,
	`color` varchar(6) NOT NULL default 'FFFFFF',
  PRIMARY KEY  (`id`),
  KEY `book_id` (`book_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_order_status_history`
--

DROP TABLE IF EXISTS `bs_order_status_history`;
CREATE TABLE IF NOT EXISTS `bs_order_status_history` (
  `id` int(11) NOT NULL default '0',
  `order_id` int(11) NOT NULL default '0',
  `status_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `ctime` int(11) NOT NULL default '0',
  `notified` enum('0','1') NOT NULL default '0',
  `notification_email` varchar(255) default NULL,
  `comments` text,
  PRIMARY KEY  (`id`),
  KEY `order_id` (`order_id`,`status_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_products`
--

DROP TABLE IF EXISTS `bs_products`;
CREATE TABLE IF NOT EXISTS `bs_products` (
  `id` int(11) NOT NULL default '0',
  `sort_order` int(11) NOT NULL default '0',
  `category_id` int(11) NOT NULL default '0',
  `image` varchar(255) default NULL,
  `cost_price` double NOT NULL default '0',
  `list_price` double NOT NULL default '0',
  `vat` double NOT NULL default '0',
  `total_price` double NOT NULL default '0',
  `supplier_company_id` int(11) NOT NULL default '0',
  `supplier_product_id` varchar(50) default NULL,
  `allow_bonus_points` enum('0','1') NOT NULL default '0',
  `special` enum('0','1') NOT NULL default '0',
  `special_list_price` double NOT NULL default '0',
  `special_total_price` double NOT NULL default '0',
  `charge_shipping_costs` enum('0','1') NOT NULL default '0',
  `stock` int(11) NOT NULL default '0',
  `bonus_points` int(11) NOT NULL default '0',
  `required_products` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `category_id` (`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_product_categories`
--

DROP TABLE IF EXISTS `bs_product_categories`;
CREATE TABLE IF NOT EXISTS `bs_product_categories` (
  `id` int(11) NOT NULL default '0',
  `sort_order` int(11) NOT NULL default '0',
  `parent_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_product_languages`
--

DROP TABLE IF EXISTS `bs_product_languages`;
CREATE TABLE IF NOT EXISTS `bs_product_languages` (
  `language_id` int(11) NOT NULL default '0',
  `product_id` int(11) NOT NULL default '0',
  `name` varchar(100) default NULL,
  `description` text,
  `short_description` varchar(255) default NULL,
  PRIMARY KEY  (`language_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_status_languages`
--

DROP TABLE IF EXISTS `bs_status_languages`;
CREATE TABLE IF NOT EXISTS `bs_status_languages` (
  `language_id` int(11) NOT NULL default '0',
  `status_id` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  `email_subject` varchar(100) default NULL,
  `email_template` longtext,
  `screen_template` text,
  `pdf_template_id` int(11) NOT NULL,
  PRIMARY KEY  (`language_id`,`status_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `bs_templates`
--

DROP TABLE IF EXISTS `bs_templates`;
CREATE TABLE IF NOT EXISTS `bs_templates` (
  `id` int(11) NOT NULL,
  `name` varchar(100) default NULL,
  `title` varchar(50) default NULL,
  `right_col` text,
  `left_col` text,
  `margin_top` int(11) NOT NULL,
  `margin_bottom` int(11) NOT NULL,
  `margin_left` int(11) NOT NULL,
  `margin_right` int(11) NOT NULL,
  `page_format` varchar(20) default NULL,
  `footer` text,
  `closing` text,
  `number_name` varchar(30) default NULL,
  `reference_name` varchar(30) default NULL,
  `date_name` varchar(30) default NULL,
  `logo` varchar(255) default NULL,
  `logo_width` int(11) NOT NULL,
  `logo_height` int(11) NOT NULL,
  `show_supplier_product_id` enum('0','1') NOT NULL,
  `show_prod_prices` enum('0','1') NOT NULL,
  `show_unit_prices` enum('0','1') NOT NULL,
  `show_total_prices` enum('0','1') NOT NULL,
  `show_vat` enum('0','1') NOT NULL,
  `book_id` int(11) NOT NULL,
  `logo_top` int(11) NOT NULL,
  `logo_left` int(11) NOT NULL,
  `left_col_top` int(11) NOT NULL,
  `left_col_left` int(11) NOT NULL,
  `right_col_top` int(11) NOT NULL,
  `right_col_left` int(11) NOT NULL,
	`show_amounts` ENUM( '0', '1' ),
	`logo_only_first_page` ENUM( '0', '1' ) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`),
  KEY `book_id` (`book_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `cf_7`;
CREATE TABLE IF NOT EXISTS `cf_7` (
  `link_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`link_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

-- 
-- Tabel structuur voor tabel `go_links_2`
-- 

DROP TABLE IF EXISTS `go_links_7`;
CREATE TABLE IF NOT EXISTS `go_links_7` (
  `id` int(11) NOT NULL,
  `folder_id` int(11) NOT NULL,
  `link_id` int(11) NOT NULL,
  `link_type` int(11) NOT NULL,
  `description` varchar(100) NULL,
  `ctime` int(11) NOT NULL,
  KEY `link_id` (`link_id`,`link_type`),
  KEY `id` (`id`,`folder_id`),
  KEY `ctime` (`ctime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `bs_cost_codes`
--

DROP TABLE IF EXISTS `bs_cost_codes`;
CREATE TABLE IF NOT EXISTS `bs_cost_codes` (
  `id` int(11) NOT NULL,
  `book_id` int(11) NOT NULL,
  `code` varchar(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `book_id` (`book_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;