GO.customfields.CategoryDialog = function(config)
	{
		if(!config)
		{
			config = {};
		}
	
		this.propertiesTab = new Ext.Panel({
			title:GO.lang['strProperties'],
			layout:'form',
			anchor: '100% 100%',
			defaults: {
				anchor: '100%'
			},
			defaultType: 'textfield',
			autoHeight:true,
			cls:'go-form-panel',
			waitMsgTarget:true,
			labelWidth: 75,
   
			items: [
			{
				fieldLabel: GO.lang['strName'],
				name: 'name',
				allowBlank:false

			}
			]
		});


		this.permissionsTab = new GO.grid.PermissionsPanel({
			title: GO.lang['strPermissions'],
			hideLevel:true
		});



		this.formPanel = new Ext.form.FormPanel({
			waitMsgTarget:true,
			url: GO.settings.modules.customfields.url+'action.php',
			//labelWidth: 75, // label settings here cascade unless overridden
			baseParams:{},
			defaultType: 'textfield',
			border:false,
			items:[{
				hideLabel:true,
				deferredRender:false,
				xtype:'tabpanel',
				activeTab: 0,
				border:false,
				anchor: '100% 100%',
				items:[
				this.propertiesTab,
				this.permissionsTab
				]
			}]
		});
	
	
		GO.customfields.CategoryDialog.superclass.constructor.call(this,{
			title: GO.customfields.lang.category,
			layout:'fit',
			modal:false,
			closeAction:'hide',
			height:500,
			width:400,
						
			items: this.formPanel,
			buttons:[
			{
				text:GO.lang['cmdOk'],
				handler: function(){
					this.save(true)
					},
				scope: this
			},
			{
				text:GO.lang['cmdApply'],
				handler: function(){
					this.save(false)
					},
				scope: this
			},

			{
				text:GO.lang['cmdClose'],
				handler: function(){
					this.hide()
					},
				scope: this
			}
			]
		});
	}

Ext.extend(GO.customfields.CategoryDialog, Ext.Window, {
	focus : function(){
		this.formPanel.form.findField('name').focus();
	},

	initComponent : function(){
		
		this.addEvents({
			'save' : true
		});
		
		GO.customfields.CategoryDialog.superclass.initComponent.call(this);		
		
	},
				
	show : function (category_id){		
		
		if(!this.rendered)
			this.render(Ext.getBody());

		this.propertiesTab.show();
		
		if(category_id > 0)
		{			
			this.loadCategory(category_id);			
		}else
		{
			this.category_id=0;
			this.formPanel.form.reset();			

			this.permissionsTab.setDisabled(true);

			GO.customfields.CategoryDialog.superclass.show.call(this);
		}
	},
	
	setType : function(link_type)
	{
		this.formPanel.baseParams['link_type']=link_type;
		
	},
	
	loadCategory : function(category_id)
	{
		if(category_id!=this.category_id)
		{
			this.formPanel.form.load({
				url: GO.settings.modules.customfields.url+'json.php',
				params: {
					category_id:category_id,
					task: 'category'
				},

				success: function(form, action) {
					this.category_id=category_id;
					this.permissionsTab.setAcl(action.result.data.acl_id);
					GO.customfields.CategoryDialog.superclass.show.call(this);
				},
				failure:function(form, action)
				{
					Ext.Msg.alert(GO.lang['strError'], action.result.feedback)
				},
				scope: this
			});
		}else
		{
			GO.customfields.CategoryDialog.superclass.show.call(this);
		}
	},
	save : function(hide)
	{
		this.formPanel.form.submit({
				
			url:GO.settings.modules.customfields.url+'action.php',
			params: {
				'task' : 'save_category',
				'category_id': this.category_id
			},
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action){
										
				if(action.result.category_id)
				{
					this.category_id=action.result.category_id;
					this.permissionsTab.setAcl(action.result.acl_id);
				}
				
				this.fireEvent('save');
				
				if(hide)
				{
					this.hide();
				}
					
					
			},

			failure: function(form, action) {
				var error = '';
				if(action.failureType=='client')
				{
					error = GO.lang['strErrorsInForm'];
				}else
				{
					error = action.result.feedback;
				}
					
				Ext.MessageBox.alert(GO.lang['strError'], error);
			},
			scope:this

		});
			
	}
});
