/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: CustomReportDialog.js 12698 2012-01-18 14:38:08Z wvbeusekom $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.CustomReportDialog = function(config){	
	if(!config)
	{
		config={};
	}
	this.buildForm();
	var focusFirstField = function(){
		this.propertiesPanel.items.items[0].focus();
	};

	config.tbar=[{
		iconCls:'btn-download',
		text:GO.lang.download,
		handler:function(){
			document.location=GO.settings.modules.projects.url+'report.php?custom_report_id='+this.custom_report_id;
		},
		scope:this,
		disabled:true
	},{
		iconCls:'btn-save',
		text:GO.lang.cmdSave,
		handler:function(){

			if(!GO.files.saveAsDialog)
			{
				GO.files.saveAsDialog = new GO.files.SaveAsDialog();
			}

			if(this.files_folder_id){
				var fb = GO.files.saveAsDialog.fb;
				fb.setRootID(fb.treeLoader.baseParams.root_folder_id, this.files_folder_id);
			}
					
			GO.files.saveAsDialog.show({
				filename: this.templateCombo.getRawValue()+'.pdf',
				handler:function(dialog, folder_id, filename){
					dialog.el.mask(GO.lang.waitMsgLoad);
					Ext.Ajax.request({
						url: GO.settings.modules.projects.url+'action.php',
						params:{
							task:'save_custom_report_pdf',
							custom_report_id: this.custom_report_id,
							folder_id: folder_id,
							filename:filename
						},
						callback: function(options, success, response)
						{
							dialog.el.unmask();
							if(!success)
							{
								alert( GO.lang['strRequestError']);
							}else
							{
								var responseParams = Ext.decode(response.responseText);
								if(!responseParams.success)
								{
									alert( responseParams.feedback);
								}else
								{
									dialog.hide();
								}
							}
						},
						scope:this
					});
				},
				scope:this
			});

		},
		scope:this,
		disabled:true
	},{
		iconCls:'btn-email',
		text:GO.projects.lang.emailProjectManagers,
		handler:function(){

			if(confirm(GO.projects.lang.confirmEmailProjectManagers)){
				Ext.Ajax.request({
					url: GO.settings.modules.projects.url+'action.php',
					params:{
						task:'email_custom_report_pdf',
						custom_report_id: this.custom_report_id
					},
					callback: function(options, success, response)
					{
						if(!success)
						{
							alert( GO.lang['strRequestError']);
						}else
						{
							var responseParams = Ext.decode(response.responseText);
							alert(responseParams.feedback);

						}
					},
					scope:this
				});
			}
		},
		scope:this
	}];

	config.collapsible=true;
	config.maximizable=true;
	config.layout='fit';
	config.modal=false;
	config.resizable=false;
	config.width=700;
	config.height=500;
	config.closeAction='hide';
	config.title= GO.projects.lang.customReport;					
	config.items= this.formPanel;
	config.focus= focusFirstField.createDelegate(this);
	config.buttons=[{
		text: GO.lang['cmdOk'],
		handler: function(){
			this.submitForm(true);
		},
		scope: this
	},{
		text: GO.lang['cmdApply'],
		handler: function(){
			this.submitForm();
		},
		scope:this
	},{
		text: GO.lang['cmdClose'],
		handler: function(){
			this.hide();
		},
		scope:this
	}
	];
	GO.projects.CustomReportDialog.superclass.constructor.call(this, config);
	this.addEvents({
		'save' : true
	});
}
Ext.extend(GO.projects.CustomReportDialog, Ext.Window,{
	show : function (custom_report_id,for_batch_report) {		
		if(!this.rendered)
		{
			this.render(Ext.getBody());
		}

		if(!GO.projects.reportTemplatesStore.loaded){

			GO.projects.reportTemplatesStore.load({
				callback:function(){
					this.show(custom_report_id,for_batch_report);
				},
				scope:this
			});
			return false;
		}

		this.formPanel.form.reset();
		this.tabPanel.setActiveTab(0);
		if(!custom_report_id)
		{
			custom_report_id=0;			
		}
		this.setCustomReportId(custom_report_id);
		
		this.singleCheck.setDisabled(for_batch_report);
		if (for_batch_report)
			this.singleCheck.setValue(false);
		
		if(this.custom_report_id>0)
		{
			this.formPanel.load({
				url : GO.settings.modules.projects.url+'json.php',
				waitMsg:GO.lang['waitMsgLoad'],
				success:function(form, action)
				{

					this.subprojectsCheck.setValue(action.result.data.batch=='subprojects');
					this.singleCheck.setValue(action.result.data.batch=='single');
					this.queryCheck.setValue(action.result.data.batch=='query');

					GO.projects.CustomReportDialog.superclass.show.call(this);
				},
				failure:function(form, action)
				{
					Ext.Msg.alert(GO.lang['strError'], action.result.feedback)
				},
				scope: this				
			});
		}else 
		{
			GO.projects.CustomReportDialog.superclass.show.call(this);
		}
		
	},
	setCustomReportId : function(custom_report_id)
	{
		this.formPanel.form.baseParams['custom_report_id']=custom_report_id;
		this.custom_report_id=custom_report_id;
		this.getTopToolbar().setDisabled(custom_report_id==0);

	//this.queryPanel.setCustomReportId(custom_report_id);
	},
	submitForm : function(hide){

		var params = {
			'task' : 'save_custom_report'
		};
		
		/*if(this.queryPanel.templatesStore.loaded){

			var checked_templates=[];
			for (var i = 0; i < this.queryPanel.templatesStore.data.items.length;  i++)
			{
				var r = this.queryPanel.templatesStore.data.items[i].data;
				
				if(!GO.util.empty(r.checked)){
					checked_templates.push(r.id);
				}
			}
			params['query_templates']=checked_templates.join(',');

			params['query_fields']=Ext.encode(this.queryPanel.fieldsGrid.getGridData());
		}*/

		this.formPanel.form.submit(
		{
			url:GO.settings.modules.projects.url+'action.php',
			params: params,
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action){
				if(action.result.custom_report_id)
				{
					this.setCustomReportId(action.result.custom_report_id);
				}
			
				this.fireEvent('save', this, this.custom_report_id);				
				if(hide)
				{
					this.hide();	
				}								
			},		
			failure: function(form, action) {
				if(action.failureType == 'client')
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);			
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});		
	},
	buildForm : function () {
		this.selectLinkField = new GO.form.SelectLink();
		this.propertiesPanel = new Ext.Panel({
			title:GO.lang['strProperties'],			
			cls:'go-form-panel',			
			layout:'form',
			autoScroll:true,
			items:[this.templateCombo =  new GO.form.ComboBox({
				xtype: 'combo',
				store:GO.projects.reportTemplatesStore,
				name:'report_template_name',
				hiddenName: 'report_template_id',
				anchor: '-20',
				fieldLabel: GO.projects.lang.reportTemplate,
				mode:'local',
				triggerAction:'all',
				forceSelection:true,
				displayField:'name',
				valueField:'id'
			}),{
				xtype:'datefield',
				format: GO.settings['date_format'],
				name: 'start_time',
				anchor: '-20',
				fieldLabel: GO.projects.lang.startTime
			},{
				xtype:'datefield',
				format: GO.settings['date_format'],
				name: 'end_time',
				anchor: '-20',
				fieldLabel: GO.projects.lang.endTime
			},{
				xtype: 'radiogroup',
				hideLabel: true,
				itemCls: 'x-check-group-alt',
				columns: 1,
				name:'batch',
				items: [
				this.singleCheck = new Ext.form.Radio({
					boxLabel: GO.projects.lang.batchReportSingle,
					name: 'batch',
					inputValue: 'single',
					checked: true
				}),
				this.subprojectsCheck = new Ext.form.Radio({
					boxLabel: GO.projects.lang.batchReportSubprojects,
					name: 'batch',
					inputValue: 'subprojects'
				}),
				this.queryCheck = new Ext.form.Radio({
					boxLabel: GO.projects.lang.batchReportQuery,
					name: 'batch',
					inputValue: 'query',
					listeners:{
						check:function(cb, checked){
							this.queryPanel.setDisabled(!checked);
						},
						scope:this
					}
				})
				]
			}]
		});

		/*this.queryPanel = new GO.projects.CustomReportQueryPanel({
			title:'query',
			disabled:true
		});*/

		this.queryPanel = new GO.advancedquery.SearchQueryPanel({
			title:'Query',
			savedQueries : false,
			type:'projects',
			disabled:true,
			fieldsUrl:GO.settings.modules.projects.url+'json.php',
			listeners:{
				search:function(panel, query){
					this.search(query);
				},
				scope:this
			}
		});

		var items  = [this.propertiesPanel, this.queryPanel];
		if(GO.customfields && GO.customfields.types["14"])
		{
			for(var i=0;i<GO.customfields.types["14"].panels.length;i++)
			{			  	
				items.push(GO.customfields.types["14"].panels[i]);
			}
		}
		this.tabPanel = new Ext.TabPanel({
			activeTab: 0,
			//deferredRender: false,
			//layoutOnTabChange:true,
			border: false,
			items: items,
			anchor: '100% 100%'
		});
		this.formPanel = new Ext.form.FormPanel({
			waitMsgTarget:true,
			url: GO.settings.modules.projects.url+'action.php',
			border: false,
			baseParams: {
				task: 'custom_report',
				project_id:0
			},
			items:this.tabPanel				
		});   
	}
});
