GO.projects.ProjectPanel = Ext.extend(GO.DisplayPanel,{	

	link_type : 5,
	
	loadParams : {
		task: 'project_with_items'
	},
	
	idParam : 'project_id',
	
	loadUrl : GO.settings.modules.projects.url+'json.php',

	subProjectsTemplate : '',

	stateId : 'pm-project-panel',

	editGoDialogId : 'project',
	
	editHandler : function(){
		GO.projects.showProjectDialog({
			project_id: this.link_id
			});		
	},
	
	initComponent : function(){


		this.subProjectsTemplate =  

		'{[this.collapsibleSectionHeader(GO.projects.lang.subprojects, "pm-subprojects-"+values.panelId, "subprojects")]}'+

		'<tpl if="values.subprojects">'+
		'<table class="display-panel" cellpadding="0" cellspacing="0" border="0" id="pm-subprojects-{panelId}">'+
				
		'<tr>'+
		'<td class="table_header_links">' + GO.lang['strName'] + '</td>'+
		'<td class="table_header_links">' + GO.projects.lang.status + '</td>'+
		'<tpl if="GO.timeregistration">'+
			'<td class="table_header_links">' + GO.projects.lang.unitsBooked + '</td>'+
		'</tpl>'+
		'<td class="table_header_links">' + GO.projects.lang.dueAt + '</td>'+		
		'</tr>'+

		'<tpl for="subprojects">'+
		'<tr>'+
		'<td><div class="go-grid-icon go-link-icon-5" style="width:auto;white-space:normal;margin-left:{margin}px;<tpl if="!GO.util.empty(icon)">background-image:url({icon}) !important;</tpl>"><a class="pm-subproject-link" href="#" onclick="GO.linkHandlers[5].call(this, {id});">{name}</a></div></td>'+
		'<td style="white-space:nowrap">{status_name}</td>'+
		'<tpl if="GO.timeregistration">'+
			'<td style="white-space:nowrap" class="{[this.getUnitsClass(values)]}">{units_booked}<tpl if="units_budget&gt;0">'+
			' / {units_budget}'+
			'</tpl></td>'+
		'</tpl>'+
		'<td style="white-space:nowrap" class="{[this.getClass(values)]}">{due_time}</td>'+
		'</tr>'+
		'</tpl>'+
		'<tpl if="!subprojects.length">'+
		'<tr><td colspan="4">'+GO.lang.strNoItems+'</td></tr>'+
		'</tpl>'+
		'</table>'+
		'</tpl>';

		
		this.template = 
		'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
		/*'<tr>'+
						'<td colspan="2" class="display-panel-heading">{template_name}: <b>{name}</b></td>'+
					'</tr>'+*/

		'<tpl if="!GO.util.empty(description)">'+
		'<tr>'+
		'<td colspan="2" class="display-panel-description"><p class="pm-description-label">'+GO.lang.strDescription+'</p>{description}</td>'+
		'</tr>'+
		'</tpl>'+

		'<tpl if="!GO.util.empty(parent_project_name)">'+
		'<tr>'+
		'<td>'+GO.projects.lang.parentProject+':</td><td><a class="pm-subproject-link" href="#" onclick="GO.linkHandlers[5].call(this, {parent_project_id});">{parent_project_name}</a></td>'+

		'</tr>'+
		'</tpl>'+

		'<tr>'+
		'<td>ID:</td><td>{id}</td>'+
		'</tr>'+

		'<tpl if="!GO.util.empty(responsible_user_name)">'+
		'<tr>'+
		'<td>'+GO.projects.lang.projectManager+':</td><td>{responsible_user_name}</td>'+
		'</tr>'+
		'</tpl>'+
					
		'<tr>'+
		'<td>'+GO.projects.lang.status+':</td><td>{status_name}</td>'+
		'</tr>'+
					
					
		'<tpl if="!GO.util.empty(customer)">'+
		'<tr>'+
		'<td>'+GO.lang.customer+':</td><td>{customer}</td>'+
		'</tr>'+
		'</tpl>'+
					
		'<tpl if="!GO.util.empty(ctime)">'+
		'<tr>'+
		'<td>'+GO.lang.strCtime+':</td><td>'+
		'{ctime}'+
		'</td>'+
		'</tr>'+
		'</tpl>'+
		'<tpl if="!GO.util.empty(contact)">'+
		'<tr>'+
		'<td>'+GO.projects.lang.contact+':</td><td>{contact}</td>'+
		'</tr>'+
		'</tpl>'+
		'<tpl if="!GO.util.empty(start_time)">'+
		'<tr>'+
		'<td>'+GO.projects.lang.startTime+':</td><td>'+
		'{start_time}'+
		'</td>'+
		'</tr>'+
		'</tpl>'+
		'<tpl if="!GO.util.empty(due_time)">'+
		'<tr>'+
		'<td>'+GO.projects.lang.dueAt+':</td><td class="{[this.getClass(values)]}">'+
		'{due_time}'+
		'</td>'+
		'</tr>'+
		'</tpl>'+

		'<tpl if="!GO.util.empty(units_booked)">'+
		'<tr>'+
		'<td>'+GO.projects.lang.unitsBooked+':</td><td class="{[this.getUnitsClass(values)]}">'+
		'{units_booked}'+
		'<tpl if="units_budget&gt;0">'+
		' / {units_budget}'+
		'</tpl>'+
		'</td>'+
		'</tr>'+
		'</tpl>'+
					
		'</table>'+
				
		this.subProjectsTemplate;
			
		if(GO.tasks)
			this.template +=GO.tasks.TaskTemplate;

		if(GO.calendar)
			this.template += GO.calendar.EventTemplate;

		this.template +=GO.linksTemplate;


		Ext.apply(this.templateConfig, {
			getClass: function(values){
						
				var cls = '';
						
				var now = new Date();
				var date = Date.parseDate(values.due_time, GO.settings.date_format);
						
						
				if(date<now)
				{
					cls = 'projects-late ';
				}
						
				if(values.archived=='1')
				{
					cls += 'projects-completed';
				}
				return cls;
			},
			getUnitsClass: function(values){
				var cls = '';
				if(values.units_budget>0 && values.units_booked>=values.units_budget)
				{
					cls = 'projects-late ';
				}

				return cls;
			}
		});
				
		if(GO.files)
		{
			Ext.apply(this.templateConfig, GO.files.filesTemplateConfig);
			this.template += GO.files.filesTemplate;
		}
		
		Ext.apply(this.templateConfig, GO.linksTemplateConfig);

		
		if(GO.comments)
		{
			this.template += GO.comments.displayPanelTemplate;
		}

		if(GO.customfields)
		{
			this.template +=GO.customfields.displayPanelTemplate;
		}

		GO.projects.ProjectPanel.superclass.initComponent.call(this);


		if(GO.documenttemplates)
		{
			this.newOODoc = new GO.documenttemplates.NewOODocumentMenuItem();
			this.newOODoc.on('create', function(){
				this.reload();
			}, this);

			this.newMenuButton.menu.add(this.newOODoc);

			GO.documenttemplates.ooTemplatesStore.on('load', function(){
				this.newOODoc.setDisabled(GO.documenttemplates.ooTemplatesStore.getCount() == 0);
			}, this);
		}

		
		if(GO.tasks)
		{
			this.scheduleCallItem = new GO.tasks.ScheduleCallMenuItem();
			this.newMenuButton.menu.add(this.scheduleCallItem);
		}

		this.newMenuButton.menu.items.each(function(mi){
			if(mi.iconCls=='go-link-icon-5'){
				mi.hide();
			}
		});
		
		this.newMenuButton.menu.add('-');	
		
		this.newMenuButton.menu.add({
			iconCls: 'go-link-icon-5',							
			text: GO.projects.lang.subproject,
			cls: 'x-btn-text-icon',
			handler: function(){
				if(GO.projects.max_projects>0 && this.store.totalLength>=GO.projects.max_projects)
				{
					Ext.Msg.alert(GO.lang.strError, GO.projects.lang.maxProjectsReached);
				}else
				{
					GO.projects.showProjectDialog({
						parent_project_id: this.data.id,
						values:{
							type_id:this.data.type_id
						}
						});
					GO.projects.projectDialog.addListenerTillHide('save', function(){
						this.reload();
					}, this);
				}
			},
			scope: this
		});
		
	},
	createTopToolbar : function(){

		var tbar = GO.projects.ProjectPanel.superclass.createTopToolbar.call(this);

		var extraMenuItems = [];

		extraMenuItems.push({
			iconCls:'btn-actions',
			text:GO.projects.lang.customReports,
			handler:function(){
				if(!this.reportsDialog)
				{
					this.reportsDialog = new GO.projects.ReportsDialog();
				}
				this.reportsDialog.show(this.data.id, this.data.files_folder_id);
			},
			scope:this
		});

		if(GO.billing){
			extraMenuItems.push({
				iconCls:'go-menu-icon-billing',
				text:GO.projects.lang.bill,
				handler:function(){
					if(!GO.projects.invoiceDialog)
					{
						GO.projects.invoiceDialog= new GO.projects.InvoiceDialog();
					}
					GO.projects.invoiceDialog.show({
						project_id:this.data.id
					});
				},
				scope:this
			});
		}		

		if(GO.timeregistration){
			extraMenuItems.push({
				iconCls:'go-menu-icon-timeregistration',
				text:GO.projects.lang.timeTracking,
				handler:function(){
					if(!this.hoursDialog)
					{
						this.hoursPanel = new GO.projects.HoursGrid({
							border:false
						});

						this.hoursDialog = new Ext.Window({
							title: GO.projects.lang.timeTracking,
							width:740,
							height:500,
							layout:'fit',
							items:this.hoursPanel,
							closeAction:'hide',
							buttons:[{
								text: GO.lang['cmdClose'],
								handler: function(){
									this.hoursDialog.hide();
								},
								scope:this
							}
							]
						});
					}

					this.hoursPanel.store.baseParams={
						'task': 'hours'
					};
					this.hoursPanel.store.baseParams.start_date = '';
					this.hoursPanel.store.baseParams.end_date = '';
					this.hoursPanel.store.baseParams.user_id = 0;//GO.settings.user_id;

					this.hoursPanel.store.baseParams.project_id=this.data.id;
					this.hoursPanel.store.load();

					this.hoursDialog.show();
				},
				scope:this
			});
		}

		extraMenuItems.push({
			itemId:'expenses',
			iconCls:'btn-actions',
			text:GO.projects.lang.expenses,
			handler:function(){
				if(!this.expensesDialog)
				{
					this.expensesDialog = new GO.projects.ExpensesWindow();
				}
				this.expensesDialog.show(this.data.id);
			},
			scope:this
		});

		extraMenuItems.push({
			itemId:'income',
			iconCls:'btn-actions',
			text:GO.projects.lang.income,
			handler:function(){
				if(!this.incomesDialog)
				{
					this.incomesDialog = new GO.projects.IncomesWindow();
				}
				this.incomesDialog.show(this.data.id);
			},
			scope:this
		});

		if(extraMenuItems.length>0){

			if(extraMenuItems.length==1){
				tbar.splice(tbar.length-2,0 ,extraMenuItems[0]);
			}else
			{
				this.extraMenu = new Ext.Button({
					iconCls:'btn-extra',

					text:GO.lang.extra,
					menu:new Ext.menu.Menu({
						items: extraMenuItems
					})
				});

				tbar.splice(tbar.length-2,0 ,this.extraMenu);
			}
		}

		return tbar;
	},
	
	setData : function(data)
	{
		GO.projects.ProjectPanel.superclass.setData.call(this, data);


		var expenses = true;
		var income = true;

		if(data.template){
			expenses = data.template.fields.indexOf('expenses')>-1;
			income = data.template.fields.indexOf('income')>-1;
		}
		this.extraMenu.menu.items.get('expenses').setDisabled(!expenses);
		this.extraMenu.menu.items.get('income').setDisabled(!income);

		if(GO.documenttemplates && !GO.documenttemplates.ooTemplatesStore.loaded)
			GO.documenttemplates.ooTemplatesStore.load();

		
		if(this.ownerCt.baseCls=='x-window'){
			this.ownerCt.setTitle(data.template_name+": <b>"+data.name+"</b>");
		}else
		{
			this.setTitle(data.template_name+": <b>"+data.name+"</b>");
		}

		//set the default calendar id
		this.newMenuButton.menu.eventShowConfig={
			calendar_id:data.calendar_id
			};
		this.newMenuButton.menu.taskShowConfig={
			tasklist_id:data.tasklist_id,
			projectName:data.name
			};
		
		if(data.write_permission)
		{
			if(this.scheduleCallItem)
			{	
				var name = this.data.name;				
				
				this.scheduleCallItem.setLinkConfig({
					name: name,
					links:[{
						link_id: this.data.id,
						link_type:5
					},{
						link_id: this.data.company_id,
						link_type:3
					}],
					callback:this.reload,
					scope: this
				});
			}
		}
	}	
});			
