/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: ReportTemplatesGrid.js 8336 2010-07-06 09:16:00Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.ReportTemplatesGrid = function(config){
	if(!config)
	{
		config = {};
	}
	config.title = GO.projects.lang.reportTemplates;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;

	config.store = GO.projects.reportTemplatesStore;
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[{
			header: GO.lang.strName,
			dataIndex: 'name'
		}]
	});
	
	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;
	
	config.tbar=[{
			iconCls: 'btn-add',							
			text: GO.lang['cmdAdd'],
			cls: 'x-btn-text-icon',
			handler: function(){
	    	this.showReportTemplateDialog();
			},
			scope: this
		},{
			iconCls: 'btn-delete',
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.deleteSelected();
			},
			scope: this
		}];

	config.listeners={
		render:function(){
			if(!this.store.loaded)
				this.store.load();			
		},
		scope:this
	};
	
	GO.projects.ReportTemplatesGrid.superclass.constructor.call(this, config);
	this.on('rowdblclick', function(grid, rowIndex){
		var record = grid.getStore().getAt(rowIndex);	
		this.showReportTemplateDialog(record.data.id);
		}, this);
};
Ext.extend(GO.projects.ReportTemplatesGrid, GO.grid.GridPanel,{
	
	showReportTemplateDialog : function(config){
		if(!this.reportTemplateDialog){
			this.reportTemplateDialog = new GO.projects.ReportTemplateDialog();
			this.reportTemplateDialog.on('save', function(){
				this.store.reload();
			}, this);
		}
		this.reportTemplateDialog.show(config);
	}
});
