/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: StatusDialog.js 7611 2010-04-13 08:38:17Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.StatusDialog = function(config){
	if(!config)
	{
		config={};
	}
	this.buildForm();
	var focusFirstField = function(){
		this.formPanel.items.items[0].focus();
	};
	config.collapsible=false;
	config.maximizable=false;
	config.layout='fit';
	config.modal=false;
	config.resizable=false;
	config.width=300;
	config.autoHeight=true;
	config.closeAction='hide';
	config.title= GO.projects.lang.status;					
	config.items= this.formPanel;
	config.focus= focusFirstField.createDelegate(this);
	config.buttons=[{
			text: GO.lang['cmdOk'],
			handler: function(){
				this.submitForm(true);
			},
			scope: this
		},{
			text: GO.lang['cmdClose'],
			handler: function(){
				this.hide();
			},
			scope:this
		}					
	];
	GO.projects.StatusDialog.superclass.constructor.call(this, config);
	this.addEvents({'save' : true});	
}
Ext.extend(GO.projects.StatusDialog, Ext.Window,{
	show : function (status_id, config) {
		if(!this.rendered)
		{
			this.render(Ext.getBody());
		}

		if(!status_id)
		{
			status_id=0;			
		}
		this.setStatusId(status_id);
		if(this.status_id>0)
		{
			this.formPanel.load({
				url : GO.settings.modules.projects.url+'json.php',
				waitMsg:GO.lang['waitMsgLoad'],
				success:function(form, action)
				{
					GO.projects.StatusDialog.superclass.show.call(this);
				},
				failure:function(form, action)
				{
					Ext.Msg.alert(GO.lang['strError'], action.result.feedback)
				},
				scope: this
			});
		}else 
		{
			this.formPanel.form.reset();
			GO.projects.StatusDialog.superclass.show.call(this);
		}
	},
	setStatusId : function(status_id)
	{
		this.formPanel.form.baseParams['status_id']=status_id;
		this.status_id=status_id;
	},
	submitForm : function(hide){
		this.formPanel.form.submit(
		{
			url:GO.settings.modules.projects.url+'action.php',
			params: {'task' : 'save_status'},
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action){
				this.fireEvent('save', this);
				if(hide)
				{
					this.hide();	
				}else
				{
					if(action.result.status_id)
					{
						this.setStatusId(action.result.status_id);
					}
				}
			},		
			failure: function(form, action) {
				if(action.failureType == 'client')
				{					
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);			
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});
	},
	buildForm : function () {

    this.formPanel = new Ext.form.FormPanel({
	    waitMsgTarget:true,
			url: GO.settings.modules.projects.url+'action.php',
			border: false,
			baseParams: {task: 'status'},				
			autoHeight:true,
			cls:'go-form-panel',
			items:[{
				xtype: 'textfield',
			  name: 'name',
				anchor: '100%',
			  fieldLabel: GO.lang.strName
			}]
		});
	}
});
