GO.mainLayout.onReady(function(){

	if(!GO.mailings){
		alert('The save e-mail as module is installed but depends on the not available mailings module. The administrator should correct this.');
		return false;
	}

	if(!GO.email){
		alert('The save e-mail as module is installed but depends on the not available e-mail module. The administrator should correct this.');
		return false;
	}
			
	GO.email.saveAsItems = GO.email.saveAsItems || [];
				
	if(GO.settings.modules.files && GO.settings.modules.files.read_permission )
	{
		GO.email.saveAsItems.push({
			text: GO.files.lang.file,
			iconCls: 'go-link-icon-6',
			handler: function(item){
					
				//scope is the mail client
				if(!GO.files.saveAsDialog)
				{
					GO.files.saveAsDialog = new GO.files.SaveAsDialog();
				}
			  	
				var records = this.messagesGrid.getSelectionModel().getSelections();
				var r = records[0].data;

				GO.files.saveAsDialog.show({
					filename: GO.util.html_entity_decode(r.subject, 'ENT_QUOTES')+'.eml',
					handler:function(dialog, folder_id, filename){
						dialog.el.mask(GO.lang.waitMsgLoad);
						Ext.Ajax.request({
							url: GO.settings.modules.savemailas.url+'action.php',
							params:{
								task:'save_email',
								uid: r.uid,
								mailbox: this.mailbox,
								account_id: this.account_id,
								folder_id: folder_id,
								filename:filename
							},
							callback: function(options, success, response)
							{
								dialog.el.unmask();
								if(!success)
								{
									alert( GO.lang['strRequestError']);
								}else
								{
									var responseParams = Ext.decode(response.responseText);
									if(!responseParams.success)
									{
										alert( responseParams.feedback);
									}else
									{
										dialog.hide();
									}
								}
							},
							scope:this
						});
					},
					scope:this
				});
				
			}
		});
	}
		
	if(GO.settings.modules.calendar && GO.settings.modules.calendar.read_permission)
	{
		GO.email.saveAsItems.push({
			text: GO.calendar.lang.appointment,
			iconCls: 'go-link-icon-1',
			handler: function(item){
				var records = this.messagesGrid.getSelectionModel().getSelections();
				var r = records[0].data;
			  	
				Ext.Ajax.request({
					url: GO.settings.modules.email.url+'json.php',
					params: {
						task: 'message',
						account_id: this.account_id,
						mailbox: this.mailbox,
						plaintext:true,
						create_temporary_attachments:true,
						get_contact_id:true,
						uid: r.uid
					},
					callback: function(options, success, response)
					{
						if(success)
						{
							var values = Ext.decode(response.responseText);
									
							values.description=values.body;
									
							var config = {
								values: values,
								tmp_files: []
							};
									
							for(var i=0;i<values.attachments.length;i++)
							{
								config.tmp_files.push({
									name:values.attachments[i].name,
									tmp_file:values.attachments[i].tmp_file
								});
							}
									
							if(values.sender_contact_id>0)
							{
								config.link_config = {
									type_id:'2:'+values.sender_contact_id,
									text: values.from
								};
							}


							if(!GO.calendar.eventDialogListeners)
								GO.calendar.eventDialogListeners=[];

							GO.calendar.eventDialogListeners.push({
								show:{
									fn:function(){
										GO.calendar.eventDialog.participantsPanel.addParticipant({
											name: values.from,
											email: values.sender,
											status: values.sender == GO.settings.email ? '1' : '0'
										});

										for(var i=0;i<values.to.length;i++)
										{
											GO.calendar.eventDialog.participantsPanel.addParticipant({
												name: values.to[i].name,
												email: values.to[i].email,
												status: values.to[i].email == GO.settings.email ? '1' : '0'
											});
										}

										GO.calendar.eventDialog.participantsPanel.reloadAvailability();
									},
									scope:this,
									single:true
								}
							});
						
							GO.calendar.showEventDialog(config);
						}
					},
					scope: this
				});
			}
		});
	}
		
	if(GO.settings.modules.notes && GO.settings.modules.notes.read_permission)
	{
		GO.email.saveAsItems.push({
			text: GO.notes.lang.note,
			iconCls: 'go-link-icon-4',
			handler: function(item){
				var records = this.messagesGrid.getSelectionModel().getSelections();
				var r = records[0].data;
			  	
				Ext.Ajax.request({
					url: GO.settings.modules.email.url+'json.php',
					params: {
						task: 'message',
						account_id: this.account_id,
						mailbox: this.mailbox,
						plaintext:true,
						create_temporary_attachments:true,
						get_contact_id:true,
						uid: r.uid
					},
					callback: function(options, success, response)
					{
						if(success)
						{
							var values = Ext.decode(response.responseText);
			
							var config = {
								values: {
									name: values.subject,
									content: values.body
								},
								tmp_files: []
							};
									
							for(var i=0;i<values.attachments.length;i++)
							{
								config.tmp_files.push({
									name:values.attachments[i].name,
									tmp_file:values.attachments[i].tmp_file
								});
							}
									
							if(values.sender_contact_id>0)
							{
								config.link_config = {
									type_id:'2:'+values.sender_contact_id,
									text: values.from
								};
							}
														
							GO.notes.showNoteDialog(0, config);
						}
					},
					scope: this
				});
			}
		});
	}
		
	if(GO.settings.modules.tasks && GO.settings.modules.tasks.read_permission)
	{
		GO.email.saveAsItems.push({
			text: GO.tasks.lang.task,
			iconCls: 'go-link-icon-12',
			handler: function(item){
				var records = this.messagesGrid.getSelectionModel().getSelections();
				var r = records[0].data;
			  	
				Ext.Ajax.request({
					url: GO.settings.modules.email.url+'json.php',
					params: {
						task: 'message',
						account_id: this.account_id,
						mailbox: this.mailbox,
						plaintext:true,
						create_temporary_attachments:true,
						get_contact_id:true,
						uid: r.uid
					},
					callback: function(options, success, response)
					{
						if(success)
						{
							var values = Ext.decode(response.responseText);
									
							values.description=values.body;
							values.name=values.subject;

							if (values.priority<3) {
								values.priority = 2;
							} else if (values.priority>3) {
								values.priority = 0;
							} else if (values.priority==3) {
								values.priority = 1;
							}

							var config = {
								values: values,
								tmp_files:[]
							};

																
							for(var i=0;i<values.attachments.length;i++)
							{
								config.tmp_files.push({
									name:values.attachments[i].name,
									tmp_file:values.attachments[i].tmp_file
								});
							}
									
							if(values.sender_contact_id>0)
							{
								config.link_config = {
									type_id:'2:'+values.sender_contact_id,
									text: values.from
								};
							}
									
							GO.tasks.showTaskDialog(config);
						}
					},
					scope: this
				});
			}
		});
	}
		
	if(GO.settings.modules.tickets && GO.settings.modules.tickets.read_permission)
	{
		GO.email.saveAsItems.push({
			text: GO.tickets.lang.ticket,
			iconCls: 'go-link-icon-20',
			handler: function(item){
				var records = this.messagesGrid.getSelectionModel().getSelections();
				var r = records[0].data;
			  	
				Ext.Ajax.request({
					url: GO.settings.modules.email.url+'json.php',
					params: {
						task: 'message',
						account_id: this.account_id,
						mailbox: this.mailbox,
						plaintext:true,
						create_temporary_attachments:true,
						get_contact_id:true,
						uid: r.uid
					},
					callback: function(options, success, response)
					{
						if(success)
						{
							var values = Ext.decode(response.responseText);

							delete values.priority;
									
							values.content=values.body;

							if(values.sender_contact_id > 0)
							{
								var contact = values.contact;

								values.contact_name=contact.contact_name;
									
								if(values.company){
									values.company_id=values.company.id;
									values.company_name=values.company.name;
								}
									
								values.first_name=contact.first_name;
								values.last_name=contact.last_name;
								values.contact_name=contact.contact_name;

								var email = '';
								if (contact.email)
									email = contact.email;
								else if (contact.email2)
									email = contact.email2;
								else if (contact.email3)
									email = contact.email3;

								values.email=email;
                                        
								var phone = '';
								if (contact.work_phone)
									phone = contact.work_phone;
								else if (contact.cellular)
									phone = contact.cellular;
								else if (contact.home_phone)
									phone = contact.home_phone;

								values.phone=phone;
							}

							delete values.company;
							delete values.contact;
									
							var config = {
								values: values,
								tmp_files:[]
							};

							if(values.sender_contact_id > 0)
							{
								config.link_config = {
									type_id:'2:'+values.sender_contact_id,
									text:values.contact_name
								}
							}
									
							for(var i=0;i<values.attachments.length;i++)
							{
								config.tmp_files.push({
									name:values.attachments[i].name,
									tmp_file:values.attachments[i].tmp_file
								});
							}
									
							GO.tickets.showTicketDialog(0, config);
						}
					},
					scope: this
				});
			}
		});
	}
		
	GO.email.saveAsItems.push({
		iconCls: 'btn-link',
		text: GO.lang.cmdLink,
		cls: 'x-btn-text-icon',
		multiple: true,
		handler: function(){
			if(!this.messagesGrid.selModel.selections.keys.length)
			{
				Ext.MessageBox.alert(GO.lang['strError'], GO.lang['noItemSelected']);
			}else
			{
				if(!this.linksDialog)
				{
					this.linksDialog = new GO.dialog.LinksDialog({
						messagesGrid : this.messagesGrid,
						sendLinkRequest : function(tolinks, to_folder_id){

							var to_folder_id = to_folder_id || 0;
								
							var uids = this.messagesGrid.selModel.selections.keys;
							var mailbox = this.messagesGrid.store.baseParams.mailbox;
							var account_id = this.messagesGrid.store.baseParams.account_id;

							var params = {
								task: 'link_messages',
								links: Ext.encode(tolinks),
								uids: Ext.encode(uids),
								mailbox: mailbox,
								account_id: account_id,
								to_folder_id : to_folder_id,
								description:this.grid.linkDescriptionField.getValue()
							};

							Ext.MessageBox.progress(GO.mailings.lang.copyingMessages, '', '');
							Ext.MessageBox.updateProgress(0, '0%', '');


							var linkRequest = function(newUids){

								if(!newUids)
								{
									params.total=uids.length;
								}else
								{
									params.uids=Ext.encode(newUids);
								}

								Ext.Ajax.request({
									url: GO.settings.modules.savemailas.url+'action.php',
									params: params,
									callback: function(options, success, response)
									{
										if(!success)
										{
											Ext.MessageBox.alert(GO.lang.strError, response.result.errors);
										}else
										{
											var responseParams = Ext.decode(response.responseText);
											if(!responseParams.success)
											{
												alert(responseParams.feedback);
												Ext.MessageBox.hide();
											}else if(responseParams.uids && responseParams.uids.length>0)
											{
												Ext.MessageBox.updateProgress(responseParams.progress, (responseParams.progress*100)+'%', '');
													
												linkRequest.call(this, responseParams.uids);
											}else
											{
												this.grid.searchGrid.getSelectionModel().clearSelections();
												Ext.MessageBox.hide();
												this.hide();
												GO.mainLayout.getModulePanel('email').messagesGrid.focus();
											}
										}
									},
									scope: this
								});
							}
							linkRequest.call(this);
						}
					});
				}
				this.linksDialog.show();
			}
		},
		scope: this
	});
	
});
