GO.sync.AddressbookDialog = function(config){

	if(!config)
	{
		config = {};
	}
    
	config.layout='fit';
	config.title=GO.sync.lang.addressbookDialogTitle;
	config.modal=false;
	config.border=false;
	config.width=400;
	config.autoHeight=true;
	config.resizable=false;
	config.plain=true;
	config.shadow=false,
	config.closeAction='hide';
	//config.items=this.formPanel;
	config.buttons=[{
		text:GO.lang['cmdOk'],
		handler: function()
		{
			this.submitForm(true)
		},
		scope: this
	},{
		text:GO.lang['cmdApply'],
		handler: function()
		{
			this.submitForm(false)
		},
		scope: this
	},{
		text:GO.lang['cmdClose'],
		handler: function()
		{
			this.hide()
		},
		scope: this
	}];
	 
   this.gridPanel=new Ext.grid.GridPanel({
    sm : new Ext.grid.RowSelectionModel(),
    
    layout:'fit',
    height: 200,
    fields: ['id','name'],
		columns:[{
			header: GO.lang.strName,
			dataIndex: 'name',
      width: 380
		}],
    store: new GO.data.JsonStore({
      url: GO.settings.modules.sync.url+ 'json.php',
      baseParams: {
        task: 'available_addressbooks_by_user'
      },
      root: 'results',
      id: 'id',
      totalProperty:'total',
      fields: ['id','name'],
      remoteSort: true
    })
  })
   
  config.items = [this.gridPanel];
  
	GO.sync.AddressbookDialog.superclass.constructor.call(this,config);
}

Ext.extend(GO.sync.AddressbookDialog, Ext.Window, {
  onShow : function()
  {
    GO.sync.AddressbookDialog.superclass.show.call(this);
    this.gridPanel.store.load();
  },
	submitForm : function(hide)
	{		
    var selectedRows = this.gridPanel.selModel.getSelections();
    
    var ids = [];

    for(i=0; i<selectedRows.length; i++)
      ids.push(selectedRows[i].data.id);

    Ext.Ajax.request({
			url:GO.settings.modules.sync.url+'action.php',
			params: {
				task:'enable_addressbooks',
				ids: Ext.encode(ids)
			},
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action)
			{				
				if(hide)
				{
					this.hide();
				}
			},
			failure: function(form, action) 
			{
				var error = '';
				if(action.failureType=='client')
				{
					error = GO.lang['strErrorsInForm'];
				}
				else
				{
					error = action.result.feedback;
				}
				Ext.MessageBox.alert(GO.lang['strError'], error);
			},
			scope:this
		});		
	}
});