/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: NoteCategoriesGrid.js
 * @copyright Copyright Intermesh
 * @author Wilmar van Beusekom <@>
 */
GO.sync.NoteCategoriesGrid = function(config){
	if(!config)
	{
		config = {};
	}

//	var SelectColumn = new GO.grid.CheckColumn({
//		header: GO.sync.lang.selectType,
//		dataIndex: 'selected',
//		width: 90,
//		disabled_field:''
//	});

	var DefaultColumn = new GO.grid.RadioColumn({
		header: GO.sync.lang.defaultType,
		dataIndex: 'default_category',
		width: 90,
        isDisabled:function(record){
			return record.get('write_permission')==0;
		}
	});

	var fields ={
		fields:['id','name', 'selected', 'default_category','write_permission'],
		columns:[{
			header: GO.notes.lang.category,
			id: 'nameCol',
			dataIndex: 'name',
			editor: new Ext.form.TextField({
				allowBlank: false
			})
		},
//		SelectColumn,
		DefaultColumn
		]
	};
	config.store = new GO.data.JsonStore({
		url: GO.settings.modules.sync.url+ 'json.php',
		baseParams: {
			task: 'note_categories_grid'
		},
		root: 'results',
		id: 'id',
		totalProperty:'total',
		fields:fields.fields,
		remoteSort: true
	});

	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:false
		},
		columns:fields.columns
	});

	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		emptyText: GO.lang['strNoItems']
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	//config.plugins = [SelectColumn, DefaultColumn];
  config.plugins = [DefaultColumn];
//	SelectColumn.on('change', function(record, newValue) {
//		if(!GO.util.empty(record.get('default_category'))&&GO.util.empty(newValue)){
//			record.set('default_category', false);
//		}
//	});

  config.tbar=[{
		iconCls: 'btn-add',
		text: GO.lang['cmdAdd'],
		cls: 'add-btn-text-icon',
		handler: function(){
      if(!this.noteCategoryDialog){
        this.noteCategoryDialog = new GO.sync.NoteCategoryDialog();
        this.noteCategoryDialog.on('hide', function(){
          this.store.reload();
        }, this);
      }
      this.noteCategoryDialog.show();
      
		},
		scope: this
	},{
		iconCls: 'btn-delete',
    text: GO.lang['cmdDelete'],
    cls: 'x-btn-text-icon',
    handler: function()
    {
      this.deleteSelected();
    },
    scope: this
	}];
	GO.sync.NoteCategoriesGrid.superclass.constructor.call(this, config);
};
Ext.extend(GO.sync.NoteCategoriesGrid, Ext.grid.GridPanel,{

  deleteSelected : function(){		
    var selectedRows = this.selModel.getSelections();
    
    var ids = [];

    for(i=0; i<selectedRows.length; i++)
      ids.push(selectedRows[i].data.id);

    Ext.Ajax.request({
			url:GO.settings.modules.sync.url+'action.php',
			params: {
				task:'delete_note_categories',
				ids: Ext.encode(ids)
			},
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action)
			{				
				this.store.reload();
			},
			failure: function(form, action) 
			{
				var error = '';
				if(action.failureType=='client')
				{
					error = GO.lang['strErrorsInForm'];
				}
				else
				{
					error = action.result.feedback;
				}
				Ext.MessageBox.alert(GO.lang['strError'], error);
			},
			scope:this
		});		
	},
	getGridData : function(){
		var data = {};
		data['def']=false
		for (var i = 0; i < this.store.data.items.length;  i++)
		{
			var r = this.store.data.items[i].data;

			data[i]={};

			for(var key in r)
			{
				data[i][key]=r[key];
				if(key == 'default_category' && r[key] == 1)
					data['def'] = true;
			}
		}
		return data;
	}
});


