/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: Stores.js 11060 2011-07-05 09:51:04Z wsmits $
 * @copyright Copyright Intermesh
 * @author Michiel Schmidt <michiel@intermesh.nl>
 * @author Merijn Schering <mschering@intermesh.nl>
 */

GO.tickets.writableTypesStore = new GO.data.JsonStore({
    url:GO.settings.modules.tickets.url+ 'json.php',
    baseParams:{
    	auth_type:'write',
    	task:'types'
    },
    root:'results',
    id:'id',
    totalProperty:'total',
    fields:['id','name','description','user_name','acl_id']
});

GO.tickets.readableTypesStore = new GO.data.JsonStore({
	url:GO.settings.modules.tickets.url+ 'json.php',
	baseParams:{
		auth_type:'read',
		task:'types'
	},
	root:'results',
	id:'id',
	totalProperty:'total',
	fields:['id','name','description','acl_id']
});
		
GO.tickets.statusesStore = new GO.data.JsonStore({
	url:GO.settings.modules.tickets.url+'json.php',
	baseParams:{
		task:'statuses',
		type_id:0
	},
	root:'results',
	id:'id',
	totalProperty:'total',
    fields:['id','name','checked','name_clean']
});

GO.tickets.agentsStore = new GO.data.JsonStore({
	url:GO.settings.modules.tickets.url+'json.php',
	baseParams:{task:'get_agents'},
	root:'results',
	id:'agent_id',
	totalProperty:'total',
  fields:['agent_id','agent_name']
});

GO.tickets.templatesStore = new GO.data.JsonStore({
    url:GO.settings.modules.tickets.url+ 'json.php',
    baseParams:{
    	task:'templates'
    },
    root:'results',
    id:'id',
    totalProperty:'total',
    fields:['id','name']
});


if(GO.settings.modules.tickets.write_permission){
	GO.tickets.ratesStore = new GO.data.JsonStore({
			url:GO.settings.modules.tickets.url+ 'json.php',
			baseParams:{
				task:'rates'
			},
			root:'results',
			id:'id',
			totalProperty:'total',
			fields:['id','name','amount']
	});
}