/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: TicketsFilterGrid.js 8181 2010-06-17 09:23:56Z mschmidt $
 * @copyright Copyright Intermesh
 * @author Michiel Schmidt <michiel@intermesh.nl>
 * @author Merijn Schering <mschering@intermesh.nl>
 */

GO.tickets.TicketsFilterGrid = function(config)
{
	if(!config)
	{
		config = {};
	}					

	if(GO.settings.modules.tickets.write_permission){
		config.bbar=[ this.showMineOnlyField = new Ext.form.Checkbox({
			boxLabel: GO.tickets.lang.showMineOnly,
			labelSeparator: '',
			handler:function()
			{
				var showMineOnly = this.showMineOnlyField.getValue();
				if(showMineOnly != this.store.reader.jsonData.show_mine_only)
				{					
					this.fireEvent('showMineOnly', this, showMineOnly);
					this.store.reload();
				}
			},
			scope:this,
			name: 'show_mine_only',
			allowBlank: true,
			ctCls:'ti-show-mine-only-cb'
		})];
	}

	config.store.on('load', function(){
		if(this.showMineOnlyField)
		{
			this.showMineOnlyField.setValue(!GO.util.empty(this.store.reader.jsonData.show_mine_only));
		}
	}, this);

	GO.tickets.TicketsFilterGrid.superclass.constructor.call(this, config);

	this.addEvents({
		showMineOnly : true
	});
	
}

Ext.extend(GO.tickets.TicketsFilterGrid, GO.grid.MultiSelectGrid);