/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: TypesGrid.js 11060 2011-07-05 09:51:04Z wsmits $
 * @copyright Copyright Intermesh
 * @author Michiel Schmidt <michiel@intermesh.nl>
 * @author Merijn Schering <mschering@intermesh.nl>
 */

GO.tickets.TypesGrid = function(config){
	
	if(!config)
	{
		config = {};
	}
	
	config.cls='go-grid3-hide-headers';
	config.title = GO.tickets.lang.types;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.store = GO.tickets.readableTypesStore;
	
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[{
			header: GO.lang.strName,
			dataIndex: 'name',
      renderer:function(value, p, record){
        if(!GO.util.empty(record.data.description))
        {
          p.attr = 'ext:qtip="'+Ext.util.Format.htmlEncode(record.data.description)+'"';
        }
        return value;
      }
		}]
	});
	config.cm=columnModel;
	
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	});
	config.sm=new Ext.grid.RowSelectionModel({
		singleSelect:true
	});
	config.loadMask=true;
	
	GO.tickets.TypesGrid.superclass.constructor.call(this, config);
	
};

Ext.extend(GO.tickets.TypesGrid, GO.grid.GridPanel,{
	
	loaded : false,
	types: new Array()
	
});